﻿Imports System.Globalization
''' <summary>
''' Converts a given ID of a Category to
''' bezeichnung of category self
''' or
''' symbol of category self
''' of
''' bezeihcnung of parent category
''' or
''' symbol of category_self
''' </summary>
Public Class catid_converter
    Implements IMultiValueConverter

    Dim v_returnparent As Boolean = False
    Public Property ReturnParent As Boolean
        Get
            Return v_returnparent
        End Get
        Set(value As Boolean)
            v_returnparent = value
        End Set
    End Property

    Dim v_returnsymbol As Boolean = False
    Public Property ReturnSymbol As Boolean
        Get
            Return v_returnsymbol
        End Get
        Set(value As Boolean)
            v_returnsymbol = value
        End Set
    End Property

    Dim v_returnfullname As Boolean = False
    Public Property ReturnFullname As Boolean
        Get
            Return v_returnfullname
        End Get
        Set(value As Boolean)
            v_returnfullname = value
        End Set
    End Property

    ''' <summary>
    ''' Value(0) => ID of category
    ''' Values(1) => Collection of categories
    ''' </summary>
    ''' <param name="values"></param>
    ''' <param name="targetType"></param>
    ''' <param name="parameter"></param>
    ''' <param name="culture"></param>
    ''' <returns></returns>
    Public Function Convert(values() As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
        If values.Length <> 2 OrElse values(0).ToString = "0" OrElse values(0) Is DependencyProperty.UnsetValue OrElse values(0) Is Nothing OrElse values(1) Is Nothing OrElse values(1) Is DependencyProperty.UnsetValue Then
            Return Nothing
        End If

        Dim v_id As Integer = System.Convert.ToInt16(values(0))
        Dim v_categories As ListCollectionView = TryCast(values(1), ListCollectionView)

        v_categories.Filter = New Predicate(Of Object)(Function(p) DirectCast(p, category_v01).cat_id = v_id)
        Dim v_found_cat As category_v01 = DirectCast(v_categories.CurrentItem, category_v01)
        If v_categories.Count = 1 Then
            v_categories.Filter = Nothing

            If ReturnParent Then
                If ReturnSymbol Then
                    'Return bezeichnung of parent category
                    If v_found_cat.nv_subcats_back Is Nothing Then
                        'Category has no parents:
                        Return Nothing
                    Else
                        Return ByteToImage(v_found_cat.nv_subcats_back.symbol_ever)
                    End If
                Else
                    'Return bezeichnung of parent category
                    If v_found_cat.nv_subcats_back Is Nothing Then
                        'Category has no parents:
                        Return "-"
                    Else
                        Return v_found_cat.nv_subcats_back.bezeichnung
                    End If
                End If
            Else
                If ReturnSymbol Then
                    Return ByteToImage(v_found_cat.symbol_ever)
                Else
                    If ReturnFullname Then
                        Return v_found_cat.fullname
                    Else

                        'return bezeichnung
                        Return v_found_cat.bezeichnung
                    End If
                End If

            End If
        Else
            Return Nothing
        End If
    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
