﻿Imports System.Collections.ObjectModel
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Reflection

''' <summary>
''' Class holds a Dependecy Property which can be used to add columns to a datagrid dynamically.
''' Currently not used because the decission was made to create a budget summary with flow documents
''' To use it on a datagrid XAML: local:BindableDatagridColumns.BindableColumns="{Binding DetailColumns}"
''' </summary>
Public Class BindableDatagridColumns
    Implements INotifyCollectionChanged

    Public Shared ReadOnly BindableColumnsProperty As DependencyProperty = DependencyProperty.RegisterAttached("BindableColumns", GetType(ObservableCollection(Of DataGridColumn)), GetType(BindableDatagridColumns), New UIPropertyMetadata(Nothing, AddressOf BindableColumnsPropertyChanged))

    Private Event CollectionChanged As NotifyCollectionChangedEventHandler Implements INotifyCollectionChanged.CollectionChanged
    Private Shared Sub BindableColumnsPropertyChanged(ByVal source As DependencyObject, ByVal e As DependencyPropertyChangedEventArgs)
        Dim dataGrid As DataGrid = TryCast(source, DataGrid)
        If dataGrid.Columns.Count > 0 Then Exit Sub
        Dim columns As ObservableCollection(Of DataGridColumn) = TryCast(e.NewValue, ObservableCollection(Of DataGridColumn))
        dataGrid.Columns.Clear()
        If columns Is Nothing Then Return

        'For Each column As DataGridColumn In columns
        '    dataGrid.Columns.Add(column)
        'Next
        For Each column As DataGridColumn In columns
            Dim dataGridOwnerProperty = column.GetType.GetProperty("DataGridOwner", BindingFlags.Instance Or BindingFlags.NonPublic)
            If Not dataGridOwnerProperty = Nothing Then dataGridOwnerProperty.SetValue(column, Nothing)
            dataGrid.Columns.Add(column)
        Next


        AddHandler columns.CollectionChanged, Sub(sender, e2)
                                                  Dim ne As NotifyCollectionChangedEventArgs = TryCast(e2, NotifyCollectionChangedEventArgs)
                                                  If ne Is Nothing Then Exit Sub
                                                  If ne.Action = NotifyCollectionChangedAction.Reset Then
                                                      dataGrid.Columns.Clear()
                                                      For Each column As DataGridColumn In ne.NewItems
                                                          dataGrid.Columns.Add(column)
                                                      Next
                                                  ElseIf ne.Action = NotifyCollectionChangedAction.Add Then
                                                      For Each column As DataGridColumn In ne.NewItems
                                                          dataGrid.Columns.Add(column)
                                                      Next
                                                  ElseIf ne.Action = NotifyCollectionChangedAction.Move Then
                                                      dataGrid.Columns.Move(ne.OldStartingIndex, ne.NewStartingIndex)
                                                  ElseIf ne.Action = NotifyCollectionChangedAction.Remove Then
                                                      For Each column As DataGridColumn In ne.OldItems
                                                          dataGrid.Columns.Remove(column)
                                                      Next
                                                  ElseIf ne.Action = NotifyCollectionChangedAction.Replace Then
                                                      dataGrid.Columns(ne.NewStartingIndex) = TryCast(ne.NewItems(0), DataGridColumn)
                                                  End If
                                              End Sub
    End Sub

    Public Shared Sub SetBindableColumns(ByVal element As DependencyObject, ByVal value As ObservableCollection(Of DataGridColumn))
        element.SetValue(BindableColumnsProperty, value)
    End Sub

    Public Shared Function GetBindableColumns(ByVal element As DependencyObject) As ObservableCollection(Of DataGridColumn)
        Return CType(element.GetValue(BindableColumnsProperty), ObservableCollection(Of DataGridColumn))
    End Function

End Class