﻿''' <summary>
''' Class defines an advanced Filter Object for a Konto
''' </summary>
Public Class cls_filter_extended
    Inherits GalaSoft.MvvmLight.ObservableObject

    'Filter possibilities:
    'Typ
    'Date
    'Value
    'Person
    'Receiver
    'Tag
    'Category

#Region "Typ"

    Dim v_aktiv_typ As Boolean = False

    Public Property aktiv_typ As Boolean
        Get
            Return v_aktiv_typ
        End Get
        Set(value As Boolean)
            If v_aktiv_typ <> value Then
                v_aktiv_typ = value
                RaisePropertyChanged("aktiv_typ")
            End If
        End Set
    End Property

    Dim v_search_typ As String = ""
    Public Property search_typ As String
        Get
            Return v_search_typ
        End Get
        Set(value As String)
            If v_search_typ <> value Then
                v_search_typ = value
                RaisePropertyChanged("search_typ")
            End If
        End Set
    End Property

#End Region
#Region "Date"
    Dim v_aktiv_time As Boolean = False

    Public Property aktiv_time As Boolean
        Get
            Return v_aktiv_time
        End Get
        Set(value As Boolean)
            If v_aktiv_time <> value Then
                v_aktiv_time = value
                RaisePropertyChanged("aktiv_time")
            End If
        End Set
    End Property

    Dim v_search_time_from As Date = Date.Now
    Public Property search_time_from As Date
        Get
            Return v_search_time_from
        End Get
        Set(value As Date)
            If v_search_time_from <> value Then
                v_search_time_from = value
                RaisePropertyChanged("search_time_from")
            End If
        End Set
    End Property

    Dim v_search_time_to As Date = Date.Now.AddDays(1)
    Public Property search_time_to As Date
        Get
            Return v_search_time_to
        End Get
        Set(value As Date)
            If v_search_time_to <> value Then
                v_search_time_to = value
                RaisePropertyChanged("search_time_to")
            End If
        End Set
    End Property

#End Region
#Region "Value"

    Dim v_aktiv_value As Boolean = False

    Public Property aktiv_value As Boolean
        Get
            Return v_aktiv_value
        End Get
        Set(value As Boolean)
            If v_aktiv_value <> value Then
                v_aktiv_value = value
                RaisePropertyChanged("aktiv_value")
            End If
        End Set
    End Property

    Dim v_search_value_from As Decimal = 0D
    Public Property search_value_from As Decimal
        Get
            Return v_search_value_from
        End Get
        Set(value As Decimal)
            If v_search_value_from <> value Then
                v_search_value_from = value
                RaisePropertyChanged("search_value_from")
            End If
        End Set
    End Property

    Dim v_search_value_to As Decimal = 0D
    Public Property search_value_to As Decimal
        Get
            Return v_search_value_to
        End Get
        Set(value As Decimal)
            If v_search_value_to <> value Then
                v_search_value_to = value
                RaisePropertyChanged("search_value_to")
            End If
        End Set
    End Property

#End Region
#Region "Note"
    Dim v_aktiv_note As Boolean = False
    Public Property aktiv_note As Boolean
        Get
            Return v_aktiv_note
        End Get
        Set(value As Boolean)
            If v_aktiv_note <> value Then
                v_aktiv_note = value
                RaisePropertyChanged("aktiv_note")
            End If
        End Set
    End Property

    Dim v_search_note As String = ""
    Public Property search_note As String
        Get
            Return v_search_note
        End Get
        Set(value As String)
            If v_search_note <> value Then
                v_search_note = value
                RaisePropertyChanged("search_note")
            End If
        End Set
    End Property

    Dim v_search_note_exact As Boolean = False
    Public Property search_note_exact As Boolean
        Get
            Return v_search_note_exact
        End Get
        Set(value As Boolean)
            If v_search_note_exact <> value Then
                v_search_note_exact = value
                RaisePropertyChanged("search_note_exact")
            End If
        End Set
    End Property
#End Region
#Region "Status"

    Dim v_aktiv_status As Boolean = False

    Public Property aktiv_status As Boolean
        Get
            Return v_aktiv_status
        End Get
        Set(value As Boolean)
            If v_aktiv_status <> value Then
                v_aktiv_status = value
                RaisePropertyChanged("aktiv_status")
            End If
        End Set
    End Property

    Dim v_search_status_ids As String = ""
    Public Property search_status_ids As String
        Get
            Return v_search_status_ids
        End Get
        Set(value As String)
            If v_search_status_ids <> value Then
                v_search_status_ids = value
                RaisePropertyChanged("search_status_ids")
            End If
        End Set
    End Property

#End Region
#Region "Person"
    Dim v_aktiv_person As Boolean = False
    Public Property aktiv_person As Boolean
        Get
            Return v_aktiv_person
        End Get
        Set(value As Boolean)
            If v_aktiv_person <> value Then
                v_aktiv_person = value
                RaisePropertyChanged("aktiv_person")
            End If
        End Set
    End Property

    Dim v_selected_person_ids As String = ""
    Public Property selected_person_ids As String
        Get
            Return v_selected_person_ids
        End Get
        Set(value As String)
            If v_selected_person_ids <> value Then
                v_selected_person_ids = value
                RaisePropertyChanged("selected_person_ids")
            End If
        End Set
    End Property

#End Region
#Region "Receiver"
    Dim v_aktiv_receiver As Boolean = False
    Public Property aktiv_receiver As Boolean
        Get
            Return v_aktiv_receiver
        End Get
        Set(value As Boolean)
            If v_aktiv_receiver <> value Then
                v_aktiv_receiver = value
                RaisePropertyChanged("aktiv_receiver")
            End If
        End Set
    End Property

    Dim v_selected_receiver_ids As String = ""
    Public Property selected_receiver_ids As String
        Get
            Return v_selected_receiver_ids
        End Get
        Set(value As String)
            If v_selected_receiver_ids <> value Then
                v_selected_receiver_ids = value
                RaisePropertyChanged("selected_receiver_ids")
            End If
        End Set
    End Property

#End Region
#Region "Tag"
    Dim v_aktiv_tag As Boolean = False
    Public Property aktiv_tag As Boolean
        Get
            Return v_aktiv_tag
        End Get
        Set(value As Boolean)
            If v_aktiv_tag <> value Then
                v_aktiv_tag = value
                RaisePropertyChanged("aktiv_tag")
            End If
        End Set
    End Property

    Dim v_selected_tag_ids As String = ""
    Public Property selected_tag_ids As String
        Get
            Return v_selected_tag_ids
        End Get
        Set(value As String)
            If v_selected_tag_ids <> value Then
                v_selected_tag_ids = value
                RaisePropertyChanged("selected_tag_ids")
            End If
        End Set
    End Property
#End Region
#Region "Category"

    Dim v_aktiv_category As Boolean = False
    Public Property aktiv_category As Boolean
        Get
            Return v_aktiv_category
        End Get
        Set(value As Boolean)
            If v_aktiv_category <> value Then
                v_aktiv_category = value
                RaisePropertyChanged("aktiv_category")
            End If
        End Set
    End Property

    Dim v_selected_category_ids As String = ""
    Public Property selected_category_ids As String
        Get
            Return v_selected_category_ids
        End Get
        Set(value As String)
            If v_selected_category_ids <> value Then
                v_selected_category_ids = value
                RaisePropertyChanged("selected_category_ids")
            End If
        End Set
    End Property

#End Region
End Class
