﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

''' <summary>
''' Defines the Stacktransactions and includes the presets
''' </summary>
Public Class cls_stacktransactiondefinition
    Inherits model_base

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Return String.Empty
        End Get
    End Property
#End Region

#Region "Presets"

    Sub New(Optional set_date As Date = Nothing, Optional set_typ As Integer = Nothing, Optional set_konto As Integer = Nothing, Optional set_status As Integer = Nothing, Optional set_receiver As Integer = Nothing,
            Optional set_person As Integer = Nothing, Optional set_category As Integer = Nothing, Optional set_tag As Integer = Nothing)
        preset_date = set_date
        preset_typ_id = set_typ
        preset_konto_id = set_konto
        preset_status_id = set_status
        preset_receiver_id = set_receiver
        preset_person_id = set_person
        preset_category_id = set_category
        v_preset_tag_id = set_tag

        __stacktransactions.Clear()
        StackTransactions = New ListCollectionView(__stacktransactions)
    End Sub

    Sub New()
        __stacktransactions.Clear()
        StackTransactions = New ListCollectionView(__stacktransactions)
    End Sub


    'Use of Presets:
    Dim v_preset_tag_id_use As Boolean = False

    'Presets:
    Dim v_preset_date As Date = Date.Now
    Dim v_preset_typ_id As Integer
    Dim v_preset_konto_id As Integer
    Dim v_preset_status_id As Integer
    Dim v_preset_receiver_id As Integer
    Dim v_preset_person_id As Integer
    Dim v_preset_category_id As Integer
    Dim v_preset_tag_id As Integer

    Public Property preset_date As Date
        Get
            Return v_preset_date
        End Get
        Set(value As Date)
            If v_preset_date <> value Then
                v_preset_date = value
                NotifyPropertyChanged("preset_date")
            End If
        End Set
    End Property

    Public Property preset_konto_id As Integer
        Get
            Return v_preset_konto_id
        End Get
        Set(value As Integer)
            If v_preset_konto_id <> value Then
                v_preset_konto_id = value
                NotifyPropertyChanged("preset_konto_id")
            End If
        End Set
    End Property

    Public Property preset_typ_id As Integer
        Get
            Return v_preset_typ_id
        End Get
        Set(value As Integer)
            If v_preset_typ_id <> value Then
                v_preset_typ_id = value
                NotifyPropertyChanged("preset_typ_id")
            End If
        End Set
    End Property

    Public Property preset_status_id As Integer
        Get
            Return v_preset_status_id
        End Get
        Set(value As Integer)
            If v_preset_status_id <> value Then
                v_preset_status_id = value
                NotifyPropertyChanged("preset_status_id")
            End If
        End Set
    End Property

    Public Property preset_receiver_id As Integer
        Get
            Return v_preset_receiver_id
        End Get
        Set(value As Integer)
            If v_preset_receiver_id <> value Then
                v_preset_receiver_id = value
                NotifyPropertyChanged("preset_receiver_id")
            End If
        End Set
    End Property

    Public Property preset_person_id As Integer
        Get
            Return v_preset_person_id
        End Get
        Set(value As Integer)
            If v_preset_person_id <> value Then
                v_preset_person_id = value
                NotifyPropertyChanged("preset_person_id")
            End If
        End Set
    End Property

    Public Property preset_category_id As Integer
        Get
            Return v_preset_category_id
        End Get
        Set(value As Integer)
            If v_preset_category_id <> value Then
                v_preset_category_id = value
                NotifyPropertyChanged("preset_category_id")
            End If
        End Set
    End Property

    Public Property preset_tag_id As Integer
        Get
            Return v_preset_tag_id
        End Get
        Set(value As Integer)
            If v_preset_tag_id <> value Then
                v_preset_tag_id = value
                NotifyPropertyChanged("preset_tag_id")
            End If
        End Set
    End Property

    'Use of Presets:

    Public Property preset_tag_id_use As Boolean
        Get
            Return v_preset_tag_id_use
        End Get
        Set(value As Boolean)
            If v_preset_tag_id_use <> value Then
                v_preset_tag_id_use = value
                NotifyPropertyChanged("preset_tag_id_use")
            End If
        End Set
    End Property

#End Region

    Private WithEvents __stacktransactions As New ObservableCollection(Of transactions_stack)
    Public Property StackTransactions As ListCollectionView



    'Sub New()
    '    __stacktransactions.Clear()
    '    StackTransactions = New ListCollectionView(__stacktransactions)
    'End Sub

    Private Sub __stacktransactions_CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs) Handles __stacktransactions.CollectionChanged
        'when adding a new item then setting the presets (if defined)
        If e.Action = NotifyCollectionChangedAction.Add Then
            Dim v_new_stacktrans As transactions_stack = CType(e.NewItems.Item(0), transactions_stack)

            If v_new_stacktrans Is Nothing Then
                Exit Sub
            Else
                'Managing presets:
                With v_new_stacktrans.cont_transaction
                    .datum = preset_date
                    .transtyp_id = preset_typ_id
                    .konto_id = preset_konto_id
                    .transstatus_id = preset_status_id
                    .receiver_id = preset_receiver_id
                    .person_id = preset_person_id
                End With
                v_new_stacktrans.cont_category_id = preset_category_id
                If preset_tag_id_use Then v_new_stacktrans.cont_tag_id = preset_tag_id
            End If

        End If
    End Sub
End Class
