﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

''' <summary>
''' Represents an entry of a booking journal
''' </summary>
Public Class bookjournal_entry_v01
    Inherits model_base

#Region "Mapped"

    Dim v_bje_id As Integer
    Dim v_bj_id As Integer

    Dim v_trans_id As Nullable(Of Integer)

    'Properties defined after Import (contains mostly a string value not the corresponding ID!)
    Dim v_status_str As String
    Dim v_typ_str As String
    Dim v_konto_str As String
    Dim v_to_konto_str As String
    Dim v_receiver_str As String
    Dim v_person_str As String
    Dim v_tag_str As String
    Dim v_category_str As String
    Dim v_note_str As String
    Dim v_datum As Date = Date.Now
    Dim v_value As Decimal = 0D


    <Key>
    Public Property bje_id As Integer
        Get
            Return v_bje_id
        End Get
        Set(value As Integer)
            If v_bje_id <> value Then
                v_bje_id = value
                NotifyPropertyChanged("bje_id")
            End If
        End Set
    End Property

    Public Property bj_id As Integer
        Get
            Return v_bj_id
        End Get
        Set(value As Integer)
            If v_bj_id <> value Then
                v_bj_id = value
                NotifyPropertyChanged("bj_id")
            End If
        End Set
    End Property

    Public Property trans_id As Nullable(Of Integer)
        Get
            Return v_trans_id
        End Get
        Set(value As Nullable(Of Integer))
            If v_trans_id <> value Then
                v_trans_id = value
                NotifyPropertyChanged("trans_id")
                NotifyPropertyChanged("link_status_image")
            End If
        End Set
    End Property

    Public Property status_str As String
        Get
            Return v_status_str
        End Get
        Set(value As String)
            If v_status_str <> value Then
                v_status_str = value
                NotifyPropertyChanged("status_str")
            End If
        End Set
    End Property

    Public Property typ_str As String
        Get
            Return v_typ_str
        End Get
        Set(value As String)
            If v_typ_str <> value Then
                v_typ_str = value
                NotifyPropertyChanged("typ_str")
            End If
        End Set
    End Property

    Public Property konto_str As String
        Get
            Return v_konto_str
        End Get
        Set(value As String)
            If v_konto_str <> value Then
                v_konto_str = value
                NotifyPropertyChanged("konto_str")
            End If
        End Set
    End Property

    Public Property to_konto_str As String
        Get
            Return v_to_konto_str
        End Get
        Set(value As String)
            If v_to_konto_str <> value Then
                v_to_konto_str = value
                NotifyPropertyChanged("to_konto_str")
            End If
        End Set
    End Property

    Public Property receiver_str As String
        Get
            Return v_receiver_str
        End Get
        Set(value As String)
            If v_receiver_str <> value Then
                v_receiver_str = value
                NotifyPropertyChanged("receiver_str")
            End If
        End Set
    End Property

    Public Property person_str As String
        Get
            Return v_person_str
        End Get
        Set(value As String)
            If v_person_str <> value Then
                v_person_str = value
                NotifyPropertyChanged("person_str")
            End If
        End Set
    End Property

    Public Property tag_str As String
        Get
            Return v_tag_str
        End Get
        Set(value As String)
            If v_tag_str <> value Then
                v_tag_str = value
                NotifyPropertyChanged("tag_str")
            End If
        End Set
    End Property

    Public Property category_str As String
        Get
            Return v_category_str
        End Get
        Set(value As String)
            If v_category_str <> value Then
                v_category_str = value
                NotifyPropertyChanged("category_str")
            End If
        End Set
    End Property

    Public Property note_str As String
        Get
            Return v_note_str
        End Get
        Set(value As String)
            If v_note_str <> value Then
                v_note_str = value
                NotifyPropertyChanged("note_str")
            End If
        End Set
    End Property

    Public Property datum As Date
        Get
            Return v_datum
        End Get
        Set(value As Date)
            If v_datum <> value Then
                v_datum = value
                NotifyPropertyChanged("datum")
            End If
        End Set
    End Property

    Public Property value As Decimal
        Get
            Return v_value
        End Get
        Set(value As Decimal)
            If v_value <> value Then
                v_value = value
                NotifyPropertyChanged("value")
            End If
        End Set
    End Property
#End Region

#Region "Navigation Properties"
    Dim v_nv_bookjournal_back As bookjournal_v01

    <ForeignKey("bj_id")>
    Public Property nv_bookjournal_back As bookjournal_v01
        Get
            Return v_nv_bookjournal_back
        End Get
        Set(value As bookjournal_v01)
            If v_nv_bookjournal_back IsNot value Then
                v_nv_bookjournal_back = value
                NotifyPropertyChanged("nv_bookjournal_back")
            End If
        End Set
    End Property

    Dim v_nv_transaction As transactions_v01

    'The 0or1 to 0or1 property has to be defined in FluentAPI (see hhhb3_model class)
    Public Overridable Property nv_transaction As transactions_v01
        Get
            Return v_nv_transaction
        End Get
        Set(value As transactions_v01)
            If v_nv_transaction IsNot value Then
                v_nv_transaction = value
                NotifyPropertyChanged("nv_transaction")
                NotifyPropertyChanged("link_status_image")
            End If
        End Set
    End Property

#End Region

#Region "Not Mapped"

    ''' <summary>
    ''' Gives back an Image depending on the link stage to a transaction:
    ''' OK => is linked to a transaction
    ''' NOK => is not linked
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property link_status_image As Byte()
        Get
            If nv_transaction Is Nothing Then
                Return ResourceDictionaryImagetoByte("link_nok")
            Else
                Return ResourceDictionaryImagetoByte("link_ok")
            End If
        End Get
    End Property


    Dim v_validation_status As Integer = 0

    ''' <summary>
    ''' Possible Values:
    ''' 0 ... unchecked
    ''' 1 ... possible duplicate
    ''' 2 ... duplicate
    ''' 3 ... no duplicate
    ''' </summary>
    ''' <returns></returns>
    <NotMapped>
    Public Property validation_status As Integer
        Get
            Return v_validation_status
        End Get
        Set(value As Integer)
            If v_validation_status <> value Then
                v_validation_status = value
                NotifyPropertyChanged("validation_status")
                NotifyPropertyChanged("val_unchecked_image")
            End If
        End Set
    End Property

    Public ReadOnly Property val_unchecked_image As Byte()
        Get
            Select Case validation_status
                Case 1
                    Return ResourceDictionaryImagetoByte("val_possible")
                Case 2
                    Return ResourceDictionaryImagetoByte("val_nok")
                Case 3
                    Return ResourceDictionaryImagetoByte("val_ok")
                Case Else
                    Return ResourceDictionaryImagetoByte("val_unchecked")
            End Select
        End Get
    End Property

    Dim v_duplicate_propability As Double = 0

    ''' <summary>
    ''' Gives Back a Integer Value that gives a duplicate propability
    ''' e.g. checked wil be date, value and also comment 
    ''' </summary>
    ''' <returns></returns>
    <NotMapped>
    Public Property duplicate_propability As Double
        Get
            Return v_duplicate_propability
        End Get
        Set(value As Double)
            If v_duplicate_propability <> value Then
                v_duplicate_propability = value
                NotifyPropertyChanged("duplicate_propability")
            End If
        End Set
    End Property

    Public Sub reset_state()
        validation_status = 0
        duplicate_propability = 0
        v_possible_link = False
    End Sub

    Dim v_possible_link As Boolean = False
    <NotMapped>
    Public Property possible_link As Boolean
        Get
            Return v_possible_link
        End Get
        Set(value As Boolean)
            If v_possible_link <> value Then
                v_possible_link = value
                NotifyPropertyChanged("possible_link")
            End If
        End Set
    End Property

    Dim v_possible_link_id As Integer
    <NotMapped>
    Public Property possible_link_id As Integer
        Get
            Return v_possible_link_id
        End Get
        Set(value As Integer)
            If v_possible_link_id <> value Then
                v_possible_link_id = value
                NotifyPropertyChanged("possible_link_id")
            End If
        End Set
    End Property


#End Region


#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            'Select Case columnName
            '    Case "bezeichnung"
            '        If String.IsNullOrEmpty(datum) Then result = "Bezeichnung darf nicht leer sein"
            '        '    Case "parent_folder_id"
            '        '        If parent_folder_id = Nothing Then result = "Ordner muss ausgewählt sein"
            '        '    Case Else
            '        '        Return result
            'End Select
            'If String.IsNullOrEmpty(result) Then
            '    v_haserrors = False
            'Else
            '    v_haserrors = True
            'End If

            NotifyPropertyChanged("hasErrors")
            'Debug.Print("KontoErrorItem hasErrors " & v_haserrors.ToString)
            Return result
        End Get
    End Property
#End Region

End Class
