﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

''' <summary>
''' Class which represents a Import Column Definition Entry holds two string the name of the column comming from the import and the selected import
''' </summary>
Public Class bookjournal_import_definition_entry_v01
    Inherits model_base

    Dim v_id As Integer
    Dim v_idef_id As Integer
    Dim v_name_import As String
    Dim v_name_selected As String

#Region "Mapped"
    <Key>
    Public Property Id As Integer
        Get
            Return v_id
        End Get
        Set(value As Integer)
            If v_id <> value Then
                v_id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property Idef_id As Integer
        Get
            Return v_idef_id
        End Get
        Set(value As Integer)
            If v_idef_id <> value Then
                v_idef_id = value
                NotifyPropertyChanged("Idef_id")
            End If
        End Set
    End Property

    Public Property name_import As String
        Get
            Return v_name_import
        End Get
        Set(value As String)
            If v_name_import <> value Then
                v_name_import = value
                NotifyPropertyChanged("name_import")
            End If
        End Set
    End Property

    Public Property name_selected As String
        Get
            Return v_name_selected
        End Get
        Set(value As String)
            If v_name_selected <> value Then
                v_name_selected = value
                NotifyPropertyChanged("name_selected")
            End If
        End Set
    End Property
#End Region

#Region "Navigation Properties"
    Dim v_nv_import_definition_back As bookjournal_import_definition_v01

    <ForeignKey("Idef_id")>
    Public Property nv_import_definition_back As bookjournal_import_definition_v01
        Get
            Return v_nv_import_definition_back
        End Get
        Set(value As bookjournal_import_definition_v01)
            If v_nv_import_definition_back IsNot value Then
                v_nv_import_definition_back = value
                NotifyPropertyChanged("nv_import_definition_back")
            End If
        End Set
    End Property
#End Region

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "bezeichnung"
                    If String.IsNullOrEmpty(name_import) Then result = "Quellspalte darf nicht leer sein"
                Case Else
                    Return result
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If

            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

End Class
