﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema

Public Class budget_2_cat_v01
    Inherits model_base

    'Interne Variablen
    Dim v_id As Integer
    'Dim v_amount As Decimal
    Dim v_budget_id As Integer
    Dim v_category_id As Integer
    Dim v_income As Boolean = False
    Dim v_should_amount_internal As Decimal = 0D
    Dim v_sumchilds As Boolean = False
    Dim v_showdetails As Boolean = False

#Region "Mapped"
    <Key>
    Public Property Id As Integer
        Get
            Return v_id
        End Get
        Set(value As Integer)
            If v_id <> value Then
                v_id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property budget_id As Integer
        Get
            Return v_budget_id
        End Get
        Set(value As Integer)
            If v_budget_id <> value Then
                v_budget_id = value
                NotifyPropertyChanged("budget_id")
            End If
        End Set
    End Property

    Public Property category_id As Integer
        Get
            Return v_category_id
        End Get
        Set(value As Integer)
            If v_category_id <> value Then
                v_category_id = value
                NotifyPropertyChanged("category_id")
            End If
        End Set
    End Property

    Public Property income As Boolean
        Get
            Return v_income
        End Get
        Set(value As Boolean)
            If v_income <> value Then
                v_income = value
                NotifyPropertyChanged("income")
            End If
        End Set
    End Property

    Public Property sumchilds As Boolean
        Get
            Return v_sumchilds
        End Get
        Set(value As Boolean)
            If v_sumchilds <> value Then
                v_sumchilds = value
                NotifyPropertyChanged("sumchilds")
            End If
        End Set
    End Property
    Public Property should_amount_internal As Decimal
        Get
            Return v_should_amount_internal
        End Get
        Set(value As Decimal)
            If v_should_amount_internal <> value Then
                v_should_amount_internal = value
                NotifyPropertyChanged("should_amount_internal")
            End If
        End Set
    End Property

    Public Property ShowDetails As Boolean
        Get
            Return v_showdetails
        End Get
        Set(value As Boolean)
            If v_showdetails <> value Then
                v_showdetails = value
                NotifyPropertyChanged("ShowDetails")
            End If
        End Set
    End Property


#End Region

#Region "Navigation Properties"
    Dim v_nv_budget_2_budcat_back As budget_v01
    Dim v_nv_category_2_budcat_back As category_v01

    <ForeignKey("budget_id")>
    Public Property nv_budget_2_budcat_back As budget_v01
        Get
            Return v_nv_budget_2_budcat_back
        End Get
        Set(value As budget_v01)
            If v_nv_budget_2_budcat_back IsNot value Then
                v_nv_budget_2_budcat_back = value
                NotifyPropertyChanged("nv_budget_2_budcat_back")
            End If
        End Set
    End Property
    <ForeignKey("category_id")>
    Public Property nv_category_2_budcat_back As category_v01
        Get
            Return v_nv_category_2_budcat_back
        End Get
        Set(value As category_v01)
            If v_nv_category_2_budcat_back IsNot value Then
                v_nv_category_2_budcat_back = value
                NotifyPropertyChanged("nv_category_2_budcat_back")
            End If
        End Set
    End Property

    Public Overridable Property nv_budget2cat_2_value As New ObservableCollection(Of budget2cat_2_value_v01)
#End Region

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Return String.Empty
            'Dim result As String = String.Empty
            'Select Case columnName
            '    Case "amount"
            '        If amount = Nothing Then result = "Betrag darf nicht leer sein"
            'End Select
            'If String.IsNullOrEmpty(result) Then
            '    v_haserrors = False
            'Else
            '    v_haserrors = True
            'End If
            'NotifyPropertyChanged("hasErrors")
            'Return result
        End Get
    End Property
#End Region

#Region "Extension"
    Public ReadOnly Property sum_soll As Decimal
        Get
            Return nv_budget2cat_2_value.Sum(Function(x) x.should_amount)
        End Get
    End Property

    Public ReadOnly Property sum_ist As Decimal
        Get
            Return nv_budget2cat_2_value.Sum(Function(x) x.is_amount)
        End Get
    End Property

    Public ReadOnly Property sum_delta As Decimal
        Get
            If income Then
                Return sum_ist - sum_soll
            Else
                Return sum_soll - sum_ist
            End If
        End Get
    End Property

    Public Sub notify_all()
        NotifyPropertyChanged("sum_soll")
        NotifyPropertyChanged("sum_ist")
        NotifyPropertyChanged("sum_delta")
    End Sub
#End Region


    '#Region "Extension"
    '    'Helper:
    '    ''' <summary>
    '    ''' Kalkuliert den Transactions Ist Wert
    '    ''' </summary>
    '    ''' <param name="v_month">Das auszuwertende Monat 1 bis 12</param>
    '    ''' <returns></returns>
    '    Private Function ist_calculator(v_month As Integer) As Decimal
    '        Try
    '            If v_month = Nothing Then Return 0
    '            If v_month > 12 Then Return 0
    '            If v_month < 1 Then Return 0

    '            If nv_budget_2_budcat_back Is Nothing Then Return 0

    '            'Das betreffende Jahr:
    '            Dim v_year As Integer = nv_budget_2_budcat_back.start_date.Year
    '            If v_year = Nothing Then Return 0

    '            Dim v_mon_start As Date = New Date(v_year, v_month, 1)
    '            Dim v_mon_end = v_mon_start.AddMonths(1).AddDays(-1)

    '            Dim v_pos_amount As Decimal = 0
    '            Dim v_neg_amount As Decimal = 0

    '            v_pos_amount = nv_category_2_budcat_back.nv_cat_trans2kat.Where(
    '                Function(x) x.nv_trans_t2k_back.datum >= v_mon_start And
    '                x.nv_trans_t2k_back.datum <= v_mon_end And
    '                x.nv_trans_t2k_back.nv_transtyp_trans_back.internal_name = "ein").Sum(Function(y) y.amount)

    '            v_neg_amount = nv_category_2_budcat_back.nv_cat_trans2kat.Where(
    '                Function(x) x.nv_trans_t2k_back.datum >= v_mon_start And
    '                x.nv_trans_t2k_back.datum <= v_mon_end And
    '                x.nv_trans_t2k_back.nv_transtyp_trans_back.internal_name = "aus").Sum(Function(y) y.amount)
    '            v_neg_amount = v_neg_amount * -1 'Negativen Wert setzen

    '            Dim v_amount As Decimal = 0
    '            v_amount = v_pos_amount + v_neg_amount
    '            'v_amount = nv_category_2_budcat_back.nv_cat_trans2kat.Where(
    '            'Function(x) x.nv_trans_t2k_back.datum >= v_mon_start And x.nv_trans_t2k_back.datum <= v_mon_end).Sum(Function(y) y.amount)
    '            Return v_amount
    '        Catch ex As Exception
    '            Debug.Print(ex.Message)
    '            Return 0
    '        End Try
    '    End Function
    '#Region "Ist-Werte"
    '    Public ReadOnly Property january_ist As Decimal
    '        Get
    '            'Aktuelle Istwerte im Monat Jänner:
    '            Return ist_calculator(1)
    '        End Get
    '    End Property
    '    Public ReadOnly Property february_ist As Decimal
    '        Get
    '            Return ist_calculator(2)
    '        End Get
    '    End Property
    '    Public ReadOnly Property march_ist As Decimal
    '        Get
    '            Return ist_calculator(3)
    '        End Get
    '    End Property
    '    Public ReadOnly Property april_ist As Decimal
    '        Get
    '            Return ist_calculator(4)
    '        End Get
    '    End Property
    '    Public ReadOnly Property mai_ist As Decimal
    '        Get
    '            Return ist_calculator(5)
    '        End Get
    '    End Property
    '    Public ReadOnly Property june_ist As Decimal
    '        Get
    '            Return ist_calculator(6)
    '        End Get
    '    End Property
    '    Public ReadOnly Property july_ist As Decimal
    '        Get
    '            Return ist_calculator(7)
    '        End Get
    '    End Property
    '    Public ReadOnly Property august_ist As Decimal
    '        Get
    '            Return ist_calculator(8)
    '        End Get
    '    End Property
    '    Public ReadOnly Property september_ist As Decimal
    '        Get
    '            Return ist_calculator(9)
    '        End Get
    '    End Property
    '    Public ReadOnly Property october_ist As Decimal
    '        Get
    '            Return ist_calculator(10)
    '        End Get
    '    End Property
    '    Public ReadOnly Property november_ist As Decimal
    '        Get
    '            Return ist_calculator(11)
    '        End Get
    '    End Property
    '    Public ReadOnly Property december_ist As Decimal
    '        Get
    '            Return ist_calculator(12)
    '        End Get
    '    End Property
    '#End Region

    '#Region "Deltas"
    '    Private Function delta_helper(v_month As Integer) As Decimal
    '        If income Then
    '            Return (amount - Math.Abs(ist_calculator(v_month))) * -1
    '        Else
    '            Return amount - Math.Abs(ist_calculator(v_month))
    '        End If
    '    End Function

    '    Public ReadOnly Property january_delta As Decimal
    '        Get
    '            Return delta_helper(1)
    '        End Get
    '    End Property
    '    Public ReadOnly Property february_delta As Decimal
    '        Get
    '            Return delta_helper(2)
    '        End Get
    '    End Property
    '    Public ReadOnly Property march_delta As Decimal
    '        Get
    '            Return delta_helper(3)
    '        End Get
    '    End Property
    '    Public ReadOnly Property april_delta As Decimal
    '        Get
    '            Return delta_helper(4)
    '        End Get
    '    End Property
    '    Public ReadOnly Property mai_delta As Decimal
    '        Get
    '            Return delta_helper(5)
    '        End Get
    '    End Property
    '    Public ReadOnly Property june_delta As Decimal
    '        Get
    '            Return delta_helper(6)
    '        End Get
    '    End Property
    '    Public ReadOnly Property july_delta As Decimal
    '        Get
    '            Return delta_helper(7)
    '        End Get
    '    End Property
    '    Public ReadOnly Property august_delta As Decimal
    '        Get
    '            Return delta_helper(8)
    '        End Get
    '    End Property
    '    Public ReadOnly Property september_delta As Decimal
    '        Get
    '            Return delta_helper(9)
    '        End Get
    '    End Property
    '    Public ReadOnly Property october_delta As Decimal
    '        Get
    '            Return delta_helper(10)
    '        End Get
    '    End Property
    '    Public ReadOnly Property november_delta As Decimal
    '        Get
    '            Return delta_helper(11)
    '        End Get
    '    End Property
    '    Public ReadOnly Property december_delta As Decimal
    '        Get
    '            Return delta_helper(12)
    '        End Get
    '    End Property
    '#End Region

    '#Region "Gesamtwerte"
    '    Public ReadOnly Property MaxGesamt As Decimal
    '        Get
    '            If amount = Nothing Then
    '                Return 0
    '            Else
    '                Return amount * 12
    '            End If
    '        End Get
    '    End Property

    '    Public ReadOnly Property MaxAus As Decimal
    '        Get
    '            Dim v_helper As Decimal = 0
    '            For i As Integer = 1 To 12
    '                v_helper += ist_calculator(i)
    '            Next
    '            Return v_helper
    '        End Get
    '    End Property

    '    Public ReadOnly Property MaxAbw As Decimal
    '        Get
    '            Return Math.Abs(MaxGesamt) - Math.Abs(MaxAus)
    '        End Get
    '    End Property
    '#End Region

    'Public ReadOnly Property maincatname As String
    '    Get
    '        If nv_category_2_budcat_back Is Nothing Then
    '            Return ""
    '        Else
    '            Return nv_category_2_budcat_back.budget_maincat_name
    '        End If

    '    End Get
    'End Property
    '#End Region
End Class
