﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

''' <summary>
''' Entity which defines an object of type message_v01
''' </summary>
Public Class message_v01
    Inherits model_base

    'Propertys:
    Dim v_Id As Integer
    Dim v_header As String
    Dim v_message As String
    Dim v_creation_date As Date = Date.Now
    Dim v_stayalive As Boolean? = False
    Dim v_lifespan As Integer = 1
    Dim v_isread As Boolean? = False
    Dim v_priority As Integer = 0
    Dim v_iserrormsg As Boolean? = False

    Sub New()

    End Sub

    Sub New(m_Header As String, m_Message As String, m_StayAlive As Boolean, Optional m_LifeSpan As Integer = 1, Optional m_Priority As Integer = 0, Optional m_isError As Boolean = False)
        header = m_Header
        message = m_Message
        stayalive = m_StayAlive
        lifespan = m_LifeSpan
        priority = m_Priority
        iserrormsg = m_isError
    End Sub

    <Key>
    Public Property Id As Integer
        Get
            Return v_Id
        End Get
        Set(value As Integer)
            If v_Id <> value Then
                v_Id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property header As String
        Get
            Return v_header
        End Get
        Set(value As String)
            If v_header <> value Then
                v_header = value
                NotifyPropertyChanged("header")
            End If
        End Set
    End Property

    Public Property message As String
        Get
            Return v_message
        End Get
        Set(value As String)
            If v_message <> value Then
                v_message = value
                NotifyPropertyChanged("message")
            End If
        End Set
    End Property

    Public Property creation_date As Date
        Get
            Return v_creation_date
        End Get
        Set(value As Date)
            If v_creation_date <> value Then
                v_creation_date = value
                NotifyPropertyChanged("creation_date")
            End If
        End Set
    End Property

    Public Property stayalive As Nullable(Of Boolean)
        Get
            Return v_stayalive
        End Get
        Set(value As Nullable(Of Boolean))
            If Not v_stayalive.Equals(value) Then
                v_stayalive = value
                NotifyPropertyChanged("stayalive")
            End If
        End Set
    End Property

    Public Property lifespan As Integer
        Get
            Return v_lifespan
        End Get
        Set(value As Integer)
            If v_lifespan <> value Then
                v_lifespan = value
                NotifyPropertyChanged("lifespan")
            End If
        End Set
    End Property

    Public Property isread As Nullable(Of Boolean)
        Get
            Return v_isread
        End Get
        Set(value As Nullable(Of Boolean))
            If Not v_isread.Equals(value) Then
                v_isread = value
                NotifyPropertyChanged("isread")
            End If
        End Set
    End Property

    Public Property iserrormsg As Nullable(Of Boolean)
        Get
            Return v_iserrormsg
        End Get
        Set(value As Nullable(Of Boolean))
            If Not v_iserrormsg.Equals(value) Then
                v_iserrormsg = value
                NotifyPropertyChanged("iserrormsg")
            End If
        End Set
    End Property

    Public Property priority As Integer
        Get
            Return v_priority
        End Get
        Set(value As Integer)
            If v_priority <> value Then
                v_priority = value
                NotifyPropertyChanged("priority")
            End If
        End Set
    End Property

#Region "NotMapped"
    Public ReadOnly Property priority_str As String
        Get
            If priority = 0 Then Return ""
            Dim _str As String = ""
            For i = 0 To priority
                _str &= "!"
            Next
            Return _str
        End Get
    End Property

    Public ReadOnly Property endoflifetime As Date
        Get
            Return creation_date.AddDays(lifespan)
        End Get
    End Property

    Public ReadOnly Property symbol_ever As Object
        Get
            Dim imageset_current As New ResourceDictionary
            'Find Resourcedictionary of iconsets:
            For Each v_dict As ResourceDictionary In Application.Current.Resources.MergedDictionaries
                If v_dict.Source.ToString.Contains("Icons_") Then
                    imageset_current = v_dict
                    Exit For
                End If
            Next

            If imageset_current Is Nothing Then Return Nothing


            If isread Then
                Return CType(imageset_current.Item("message_read"), BitmapImage)
            Else
                Return CType(imageset_current.Item("message_unread"), BitmapImage)
            End If
        End Get
    End Property

#End Region


#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "header"
                    If String.IsNullOrEmpty(header) Then result = "Überschrift darf nicht leer sein"
                Case Else
                    Return result
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            Return result
        End Get
    End Property
#End Region

End Class
