﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema

''' <summary>
''' Entität für Settings
''' </summary>
Public Class settings
    Inherits model_base

    'Because of the special situation with the document backup path we have to overwrite the edit routines:
    Public Overrides Sub BeginEdit()
        MyBase.BeginEdit()
        v_old_docwatcherpath = doc_watcher_path
    End Sub

    Public Overrides Sub EndEdit()
        MyBase.EndEdit()
        v_old_docwatcherpath = ""
    End Sub

    Public Overrides Sub CancelEdit()
        MyBase.CancelEdit()
        v_old_docwatcherpath = ""
    End Sub

    Dim v_old_docwatcherpath As String = ""
    Public ReadOnly Property old_docwatcherpath As String
        Get
            Return v_old_docwatcherpath
        End Get
    End Property


#Region "Settings"
    Dim v_settingid As Integer
    <Key>
    Public Property settingId As Integer
        Get
            Return v_settingid
        End Get
        Set(value As Integer)
            If v_settingid <> value Then
                v_settingid = value
                NotifyPropertyChanged("settingId")
            End If
        End Set
    End Property

    'New in HHHB3 the name of the current used computer is saved to store the backup paths and everything else which is bound to a computer
    Dim v_computername As String = Environment.MachineName
    Public Property computername As String
        Get
            Return v_computername
        End Get
        Set(value As String)
            If v_computername <> value Then
                v_computername = value
                NotifyPropertyChanged("computername")
            End If
        End Set
    End Property

    Dim v_basic_dbname As String
    Public Property basic_dbname As String
        Get
            Return v_basic_dbname
        End Get
        Set(value As String)
            If v_basic_dbname <> value Then
                v_basic_dbname = value
                NotifyPropertyChanged("basic_dbname")
            End If
        End Set
    End Property

    Dim v_basic_db_version As String = "1.0.0.0"
    Public Property basic_db_version As String
        Get
            Return v_basic_db_version
        End Get
        Set(value As String)
            If v_basic_db_version <> value Then
                v_basic_db_version = value
                NotifyPropertyChanged("basic_db_version")
            End If
        End Set
    End Property

    Dim v_basic_transaction_sound As Boolean? = False
    Public Property basic_transaction_sound As Boolean?
        Get
            Return v_basic_transaction_sound
        End Get
        Set(value As Boolean?)
            If v_basic_transaction_sound <> value Then
                v_basic_transaction_sound = value
                NotifyPropertyChanged("basic_transaction_sound")
            End If
        End Set
    End Property

    Dim v_home_columns As Integer = 3
    Public Property home_columns As Integer
        Get
            Return v_home_columns
        End Get
        Set(value As Integer)
            If v_home_columns <> value Then
                v_home_columns = value
                NotifyPropertyChanged("home_columns")
            End If
        End Set
    End Property

    Dim v_home_locked As Boolean = False
    Public Property home_locked As Boolean
        Get
            Return v_home_locked
        End Get
        Set(value As Boolean)
            If v_home_locked <> value Then
                v_home_locked = value
                NotifyPropertyChanged("home_locked")
            End If
        End Set
    End Property

    Dim v_doc_path As String = ""
    Public Property doc_path As String
        Get
            Return v_doc_path
        End Get
        Set(value As String)
            If v_doc_path <> value Then
                v_doc_path = value
                NotifyPropertyChanged("doc_path")
            End If
        End Set
    End Property

    Dim v_doc_use_subfolder As Boolean? = True
    Public Property doc_use_subfolder As Boolean?
        Get
            Return v_doc_use_subfolder
        End Get
        Set(value As Boolean?)
            If v_doc_use_subfolder <> value Then
                v_doc_use_subfolder = value
                NotifyPropertyChanged("doc_use_subfolder")
            End If
        End Set
    End Property

    Dim v_doc_delete_after_import As Boolean? = False
    Public Property doc_delete_after_import As Boolean?
        Get
            Return v_doc_delete_after_import
        End Get
        Set(value As Boolean?)
            If v_doc_delete_after_import <> value Then
                v_doc_delete_after_import = value
                NotifyPropertyChanged("doc_delete_after_import")
            End If
        End Set
    End Property

    Dim v_doc_move_if_deleted As Boolean? = True
    Public Property doc_move_if_deleted As Boolean?
        Get
            Return v_doc_move_if_deleted
        End Get
        Set(value As Boolean?)
            If v_doc_move_if_deleted <> value Then
                v_doc_move_if_deleted = value
                NotifyPropertyChanged("doc_move_if_deleted")
            End If
        End Set
    End Property

    'Document Watcher:
    Dim v_doc_watcher_use As Boolean? = False
    Public Property doc_watcher_use As Boolean?
        Get
            Return v_doc_watcher_use
        End Get
        Set(value As Boolean?)
            If v_doc_watcher_use <> value Then
                v_doc_watcher_use = value
                NotifyPropertyChanged("doc_watcher_use")
            End If
        End Set
    End Property

    Dim v_doc_watcher_path As String = ""
    Public Property doc_watcher_path As String
        Get
            Return v_doc_watcher_path
        End Get
        Set(value As String)
            If v_doc_watcher_path <> value Then
                v_doc_watcher_path = value
                NotifyPropertyChanged("doc_watcher_path")
            End If
        End Set
    End Property

    Dim v_doc_watcher_notify_only As Boolean? = False
    Public Property doc_watcher_notify As Boolean?
        Get
            Return v_doc_watcher_notify_only
        End Get
        Set(value As Boolean?)
            If v_doc_watcher_notify_only <> value Then
                v_doc_watcher_notify_only = value
                NotifyPropertyChanged("doc_watcher_notify_only")
            End If
        End Set
    End Property

    Dim v_update_checkstartup As Boolean? = True
    Public Property update_checkstartup As Boolean?
        Get
            Return v_update_checkstartup
        End Get
        Set(value As Boolean?)
            If v_update_checkstartup <> value Then
                v_update_checkstartup = value
                NotifyPropertyChanged("update_checkstartup")
            End If
        End Set
    End Property

    Dim v_update_alpha As Boolean? = False
    Public Property update_alpha As Boolean?
        Get
            Return v_update_alpha
        End Get
        Set(value As Boolean?)
            If v_update_alpha <> value Then
                v_update_alpha = value
                NotifyPropertyChanged("update_alpha")
            End If
        End Set
    End Property

    Dim v_update_beta As Boolean? = False
    Public Property update_beta As Boolean?
        Get
            Return v_update_beta
        End Get
        Set(value As Boolean?)
            If v_update_beta <> value Then
                v_update_beta = value
                NotifyPropertyChanged("update_beta")
            End If
        End Set
    End Property

    Dim v_backup_onstartup As Boolean? = True
    Public Property backup_onstartup As Boolean?
        Get
            Return v_backup_onstartup
        End Get
        Set(value As Boolean?)
            If v_backup_onstartup <> value Then
                v_backup_onstartup = value
                NotifyPropertyChanged("backup_onstartup")
            End If
        End Set
    End Property

    Dim v_backup_onshutdown As Boolean? = False
    Public Property backup_onshutdown As Boolean?
        Get
            Return v_backup_onshutdown
        End Get
        Set(value As Boolean?)
            If v_backup_onshutdown <> value Then
                v_backup_onshutdown = value
                NotifyPropertyChanged("backup_onshutdown")
            End If
        End Set
    End Property

    Dim v_backup_count As Integer = 5
    Public Property backup_count As Integer
        Get
            Return v_backup_count
        End Get
        Set(value As Integer)
            If v_backup_count <> value Then
                v_backup_count = value
                NotifyPropertyChanged("backup_count")
            End If
        End Set
    End Property

    Dim v_backup_path As String = ""
    Public Property backup_path As String
        Get
            Return v_backup_path
        End Get
        Set(value As String)
            If v_backup_path <> value Then
                v_backup_path = value
                NotifyPropertyChanged("backup_path")
            End If
        End Set
    End Property

    Dim v_active_templates As Boolean? = True
    Public Property active_templates As Boolean?
        Get
            Return v_active_templates
        End Get
        Set(value As Boolean?)
            If v_active_templates <> value Then
                v_active_templates = value
                NotifyPropertyChanged("active_templates")
            End If
        End Set
    End Property

    Dim v_active_trans_rep As Boolean? = True
    Public Property active_trans_rep As Boolean?
        Get
            Return v_active_trans_rep
        End Get
        Set(value As Boolean?)
            If v_active_trans_rep <> value Then
                v_active_trans_rep = value
                NotifyPropertyChanged("active_trans_rep")
            End If
        End Set
    End Property

    Dim v_active_subkats As Boolean? = True
    Public Property active_subkats As Boolean?
        Get
            Return v_active_subkats
        End Get
        Set(value As Boolean?)
            If v_active_subkats <> value Then
                v_active_subkats = value
                NotifyPropertyChanged("active_subkats")
            End If
        End Set
    End Property

    Dim v_active_receiver As Boolean? = True
    Public Property active_receiver As Boolean?
        Get
            Return v_active_receiver
        End Get
        Set(value As Boolean?)
            If v_active_receiver <> value Then
                v_active_receiver = value
                NotifyPropertyChanged("active_receiver")
            End If
        End Set
    End Property

    Dim v_active_person As Boolean? = True
    Public Property active_person As Boolean?
        Get
            Return v_active_person
        End Get
        Set(value As Boolean?)
            If v_active_person <> value Then
                v_active_person = value
                NotifyPropertyChanged("active_person")
            End If
        End Set
    End Property

    Dim v_active_status As Boolean? = True
    Public Property active_status As Boolean?
        Get
            Return v_active_status
        End Get
        Set(value As Boolean?)
            If v_active_status <> value Then
                v_active_status = value
                NotifyPropertyChanged("active_status")
            End If
        End Set
    End Property

    Dim v_active_budgets As Boolean? = True
    Public Property active_budgets As Boolean?
        Get
            Return v_active_budgets
        End Get
        Set(value As Boolean?)
            If v_active_budgets <> value Then
                v_active_budgets = value
                NotifyPropertyChanged("active_budgets")
            End If
        End Set
    End Property

    Dim v_active_reports As Boolean? = True
    Public Property active_reports As Boolean?
        Get
            Return v_active_reports
        End Get
        Set(value As Boolean?)
            If v_active_reports <> value Then
                v_active_reports = value
                NotifyPropertyChanged("active_reports")
            End If
        End Set
    End Property

    Dim v_active_docs As Boolean? = True
    Public Property active_docs As Boolean?
        Get
            Return v_active_docs
        End Get
        Set(value As Boolean?)
            If v_active_docs <> value Then
                v_active_docs = value
                NotifyPropertyChanged("active_docs")
            End If
        End Set
    End Property

    Dim v_active_tags As Boolean? = True
    Public Property active_tags As Boolean?
        Get
            Return v_active_tags
        End Get
        Set(value As Boolean?)
            If v_active_tags <> value Then
                v_active_tags = value
                NotifyPropertyChanged("active_tags")
            End If
        End Set
    End Property

    'Colors:
    Dim v_color_pos_value As String = "#FF008023"
    Public Property color_pos_value As String
        Get
            Return v_color_pos_value
        End Get
        Set(value As String)
            If v_color_pos_value <> value Then
                v_color_pos_value = value
                NotifyPropertyChanged("color_pos_value")
                NotifyPropertyChanged("color_pos_value_brush")
            End If
        End Set
    End Property

    Dim v_color_neg_value As String = "#FFEC1313"
    Public Property color_neg_value As String
        Get
            Return v_color_neg_value
        End Get
        Set(value As String)
            If v_color_neg_value <> value Then
                v_color_neg_value = value
                NotifyPropertyChanged("color_neg_value_brush")
            End If
        End Set
    End Property


#Region "Reports"
    Dim v_header_fontsize As Double = 16
    Dim v_row_fontsize As Double = 12
    Dim v_color_background_header As String = "#FFA9A9A9"
    Dim v_color_background_oddrow As String = "#FFDCDCDC"
    Dim v_color_background_justrow As String = "#FFFFFFFF"

    Public Property header_fontsize As Double
        Get
            Return v_header_fontsize
        End Get
        Set(value As Double)
            If v_header_fontsize <> value Then
                v_header_fontsize = value
                NotifyPropertyChanged("header_fontsize")
            End If
        End Set
    End Property

    Public Property row_fontsize As Double
        Get
            Return v_row_fontsize
        End Get
        Set(value As Double)
            If v_row_fontsize <> value Then
                v_row_fontsize = value
                NotifyPropertyChanged("row_fontsize")
            End If
        End Set
    End Property

    Public Property color_background_header As String
        Get
            Return v_color_background_header
        End Get
        Set(value As String)
            If v_color_background_header <> value Then
                v_color_background_header = value
                NotifyPropertyChanged("color_background_header")
                NotifyPropertyChanged("color_background_header_brush")
            End If
        End Set
    End Property

    Public ReadOnly Property color_pos_value_brush As Brush
        Get
            If color_pos_value = "" Then
                Return Brushes.Green
            Else
                Dim v_brush As Brush = CType(New BrushConverter().ConvertFromString(color_pos_value), Brush)
                If v_brush Is Nothing Then
                    Return Brushes.Green
                Else
                    Return v_brush
                End If
            End If
        End Get
    End Property

    Public ReadOnly Property color_neg_value_brush As Brush
        Get
            If color_neg_value = "" Then
                Return Brushes.Red
            Else
                Dim v_brush As Brush = CType(New BrushConverter().ConvertFromString(color_neg_value), Brush)
                If v_brush Is Nothing Then
                    Return Brushes.Red
                Else
                    Return v_brush
                End If
            End If
        End Get
    End Property

    Public ReadOnly Property color_background_header_brush As Brush
        Get
            If color_background_header = "" Then
                Return Brushes.DarkGray
            Else
                Dim v_brush As Brush = CType(New BrushConverter().ConvertFromString(color_background_header), Brush)
                If v_brush Is Nothing Then
                    Return Brushes.DarkGray
                Else
                    Return v_brush
                End If
            End If
        End Get
    End Property

    Public Property color_background_oddrow As String
        Get
            Return v_color_background_oddrow
        End Get
        Set(value As String)
            If v_color_background_oddrow <> value Then
                v_color_background_oddrow = value
                NotifyPropertyChanged("color_background_oddrow")
                NotifyPropertyChanged("color_background_oddrow_brush")
            End If
        End Set
    End Property

    Public ReadOnly Property color_background_oddrow_brush As Brush
        Get
            If v_color_background_oddrow = "" Then
                Return Brushes.Gainsboro
            Else
                Dim v_brush As Brush = CType(New BrushConverter().ConvertFromString(v_color_background_oddrow), Brush)
                If v_brush Is Nothing Then
                    Return Brushes.Gainsboro
                Else
                    Return v_brush
                End If
            End If
        End Get
    End Property

    Public Property color_background_justrow As String
        Get
            Return v_color_background_justrow
        End Get
        Set(value As String)
            If v_color_background_justrow <> value Then
                v_color_background_justrow = value
                NotifyPropertyChanged("color_background_justrow")
                NotifyPropertyChanged("color_background_justrow_brush")
            End If
        End Set
    End Property

    Public ReadOnly Property color_background_justrow_brush As Brush
        Get
            If color_background_justrow = "" Then
                Return Brushes.White
            Else
                Dim v_brush As Brush = CType(New BrushConverter().ConvertFromString(color_background_justrow), Brush)
                If v_brush Is Nothing Then
                    Return Brushes.White
                Else
                    Return v_brush
                End If
            End If
        End Get
    End Property

#End Region

#End Region


#Region "Menüsystem"
    ''' <summary>
    ''' Statische Bezeichnung für das Avalon Dock
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property bezeichnung As String
        Get
            Return "Einstellungen"
        End Get
    End Property

    <NotMapped>
    Public Property cmdClose() As New RelayCommand(AddressOf Close, Function() CanClose = True)

    Private _isclosed As Boolean

    <NotMapped>
    Public Property IsClosed() As Boolean
        Get
            Return _isclosed
        End Get
        Set(value As Boolean)
            If _isclosed <> value Then
                _isclosed = value
                NotifyPropertyChanged("isClosed")

            End If
        End Set
    End Property

    Private _CanClose As Boolean = True


    <NotMapped>
    Public Property CanClose() As Boolean
        Get
            Return _CanClose
        End Get
        Set
            If _CanClose <> Value Then
                _CanClose = Value
                NotifyPropertyChanged("CanClose")
            End If
        End Set
    End Property

    Public Sub Close()
        If isinEdit Then
            Dim MVModel As HHHB3.ViewModel.MainViewModel = GalaSoft.MvvmLight.Ioc.SimpleIoc.Default.GetInstance(Of HHHB3.ViewModel.MainViewModel)()
            If MVModel IsNot Nothing Then MVModel.cmdSaveSettings.Execute(True)
        Else
            IsClosed = True
            NotifyPropertyChanged("IsClosed")
        End If
    End Sub
#End Region
End Class