﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema

Public Class trans_status_v01
    Inherits model_base

    'Interne Variablen
    Dim v_status_id As Integer
    Dim v_bezeichnung As String
    Dim v_color As String = "#000000"
    Dim v_symbol As Byte()
    Dim v_aktiv As Nullable(Of Boolean) = True
    Dim v_predefined As Nullable(Of Boolean) = False
    Dim v_shortcut_key As String

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "bezeichnung"
                    If String.IsNullOrEmpty(bezeichnung) Then result = "Bezeichnung darf nicht leer sein"
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

#Region "Mapped"
    <Key>
    Public Property status_id As Integer
        Get
            Return v_status_id
        End Get
        Set(value As Integer)
            If v_status_id <> value Then
                v_status_id = value
                NotifyPropertyChanged("status_id")
            End If
        End Set
    End Property

    Public Property bezeichnung As String
        Get
            Return v_bezeichnung
        End Get
        Set(value As String)
            If v_bezeichnung <> value Then
                v_bezeichnung = value
                NotifyPropertyChanged("bezeichnung")
            End If
        End Set
    End Property

    Public Property color As String
        Get
            Return v_color
        End Get
        Set(value As String)
            If v_color <> value Then
                v_color = value
                NotifyPropertyChanged("color")
                NotifyPropertyChanged("solid_color")
            End If
        End Set
    End Property

    <MaxLength>
    Public Property symbol As Byte()
        Get
            Return v_symbol
        End Get
        Set(value As Byte())
            If v_symbol IsNot value Then
                v_symbol = value
                NotifyPropertyChanged("symbol")
                NotifyPropertyChanged("symbol_ever")
            End If
        End Set
    End Property

    Public Property aktiv As Nullable(Of Boolean)
        Get
            Return v_aktiv
        End Get
        Set(value As Nullable(Of Boolean))
            If Not v_aktiv.Equals(value) Then
                v_aktiv = value
                NotifyPropertyChanged("aktiv")
            End If
        End Set
    End Property

    Public Property predefined As Nullable(Of Boolean)
        Get
            Return v_predefined
        End Get
        Set(value As Nullable(Of Boolean))
            If Not v_predefined.Equals(value) Then
                v_predefined = value
                NotifyPropertyChanged("predefined")
            End If
        End Set
    End Property

    Public Property shortcut_key As String
        Get
            Return v_shortcut_key
        End Get
        Set(value As String)
            If v_shortcut_key <> value Then
                v_shortcut_key = value
                NotifyPropertyChanged("shortcut_key")
            End If
        End Set
    End Property
#End Region


#Region "Navigation Properties"
    Public Overridable Property nv_transstatus_trans As New ObservableCollection(Of transactions_v01)
    Public Overridable Property trans_reps As New ObservableCollection(Of transactions_repeat_v01)
    Public Overridable Property nv_transstatus_2_transtemp As New ObservableCollection(Of transactions_template_v01)
#End Region

#Region "Extension"
    ''' <summary>
    ''' Property offers a SolidColorBrush out of the String HTML Color to change Foreground Color of an Item.
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property solid_color() As SolidColorBrush
        Get
            If color Is Nothing Then
                Return ColorBrushFromResources("IdealForegroundColorBrush")
            Else
                Try
                    Dim v_col As System.Drawing.Color = System.Drawing.ColorTranslator.FromHtml(color)
                    Dim v_color As Color = System.Windows.Media.Color.FromArgb(v_col.A, v_col.R, v_col.G, v_col.B)
                    Return New SolidColorBrush(v_color)
                Catch ex As Exception
                    Return ColorBrushFromResources("IdealForegroundColorBrush")
                End Try
            End If
        End Get
    End Property

    Public ReadOnly Property symbol_ever() As Byte()
        Get
            If symbol Is Nothing Then
                Return ResourceDictionaryImagetoByte("Status")
            Else
                Return symbol
            End If
        End Get
    End Property

    'Helfer Property um dem Status einen Wert zu geben:
    Dim v_amount As Decimal = 0
    <NotMapped>
    Public Property amount As Decimal
        Get
            Return v_amount
        End Get
        Set(value As Decimal)
            If v_amount <> value Then
                v_amount = value
                NotifyPropertyChanged("amount")
                Debug.Print("trans_status_v01 amount changed to: " & v_amount.ToString)
            End If
        End Set
    End Property
#End Region

End Class
