Imports System.Data.Entity
Imports System.Data.Entity.Infrastructure
Imports System.Data.Entity.Validation
Imports HHHB3

Public Class hhhb3_model
    Inherits DbContext

    ' Your context has been configured to use a 'hhhb2_model' connection string from your application's 
    ' configuration file (App.config or Web.config). By default, this connection string targets the 
    ' 'HHHB3.hhhb3_model' database on your LocalDb instance. 
    ' 
    ' If you wish to target a different database and/or database provider, modify the 'hhhb3_model' 
    ' connection string in the application configuration file.
    Public Sub New()
        MyBase.New("name=hhhb3_model")
        Dim v_test As Boolean = True
        Dim v_lastused_db_path As String = GetValueFromRegistryKey("db_lastused")
        Try
            v_test = IO.File.Exists(v_lastused_db_path)
        Catch ex As Exception
            cls_logger.v_logger.Info("hhhb3_model db_lastused not existent")
            v_test = False
        End Try
        If v_test = False Then
            Database.SetInitializer(New HHHB3CreateDatabaseIfNotExists)
            cls_logger.v_logger.Info("Initializer: CreateDatabaseIfNotExists")
        Else
            Database.SetInitializer(New MigrateDatabaseToLatestVersion(Of hhhb3_model, Migrations.Configuration))
            cls_logger.v_logger.Info("Initializer: MigrateDatabaseToLatestVersion")
            Debug.Print("Initializer: MigrateDatabaseToLatestVersion")
        End If
        'Do not activate this until you realy want to destroy your operative database ;)
        'Database.SetInitializer(New HHHB3DropAlwaysInitializer)
    End Sub

    Protected Overrides Function ValidateEntity(entityEntry As DbEntityEntry, items As IDictionary(Of Object, Object)) As DbEntityValidationResult
        Debug.Print("Validieren")
        cls_logger.v_logger.Info("Modell validieren")
        Return MyBase.ValidateEntity(entityEntry, items)
    End Function

    Protected Overrides Sub OnModelCreating(modelBuilder As DbModelBuilder)
        'MyBase.OnModelCreating(modelBuilder)
        'modelBuilder.Entity(Of Student)().HasOptional(Function(s) s.Address).WithRequired(Function(ad) ad.Student)
        modelBuilder.Entity(Of transactions_v01)().HasOptional(Function(s) s.nv_journal).WithOptionalPrincipal(Function(x) x.nv_transaction)
    End Sub

    ' Add a DbSet for each entity type that you want to include in your model. For more information 
    ' on configuring and using a Code First model, see http:'go.microsoft.com/fwlink/?LinkId=390109.
    ' Public Overridable Property MyEntities() As DbSet(Of MyEntity)
    Public Overridable Property m_budget_2_cat_v01 As DbSet(Of budget_2_cat_v01)
    Public Overridable Property m_budget_v01 As DbSet(Of budget_v01)
    Public Overridable Property m_budget2cat_2_value_v01 As DbSet(Of budget2cat_2_value_v01)
    Public Overridable Property m_category_v01 As DbSet(Of category_v01)
    Public Overridable Property m_documents_v01 As DbSet(Of documents_v01)
    Public Overridable Property m_folder_v01 As DbSet(Of folder_v01)
    Public Overridable Property m_konto_v01 As DbSet(Of konto_v01)
    Public Overridable Property m_person_v01 As DbSet(Of person_v01)
    Public Overridable Property m_receiver_v01 As DbSet(Of receiver_v01)
    Public Overridable Property m_searchdefinition_v01 As DbSet(Of searchdefinition_v01)
    Public Overridable Property m_searchitem_v01 As DbSet(Of searchitem_v01)
    Public Overridable Property m_tags_v01 As DbSet(Of tags_v01)
    Public Overridable Property m_trans_2_kat As DbSet(Of trans_2_kat)
    Public Overridable Property m_trans_status_v01 As DbSet(Of trans_status_v01)
    Public Overridable Property m_trans_tag_v01 As DbSet(Of trans_tag_v01)
    Public Overridable Property m_transrep_tag_v01 As DbSet(Of transrep_tag_v01)
    Public Overridable Property m_transtemp_tag_v01 As DbSet(Of transtemp_tag_v01)
    Public Overridable Property m_trans_typ_v01 As DbSet(Of trans_typ_v01)
    Public Overridable Property m_transactions_repeat_v01 As DbSet(Of transactions_repeat_v01)
    Public Overridable Property m_transactions_template_v01 As DbSet(Of transactions_template_v01)
    Public Overridable Property m_transactions_v01 As DbSet(Of transactions_v01)
    Public Overridable Property m_transrep_2_kat As DbSet(Of transrep_2_kat)
    Public Overridable Property m_transtemp_2_kat As DbSet(Of transtemp_2_kat)
    Public Overridable Property m_settings As DbSet(Of settings)
    Public Overridable Property m_bookjournal_v01 As DbSet(Of bookjournal_v01)
    Public Overridable Property m_bookjournal_entry_v01 As DbSet(Of bookjournal_entry_v01)
    Public Overridable Property m_import_definition_head As DbSet(Of import_definition_head)
    Public Overridable Property m_import_definition_row As DbSet(Of import_definition_row)
    Public Overridable Property m_bookjournal_import_definition_v01 As DbSet(Of bookjournal_import_definition_v01)
    Public Overridable Property m_bookjournal_import_definition_entry_v01 As DbSet(Of bookjournal_import_definition_entry_v01)
    Public Overridable Property m_message_v01 As DbSet(Of message_v01)
    Public Overridable Property m_widgets_v01 As DbSet(Of widgets_v01)
    Public Overridable Property m_savingtargets_v01 As DbSet(Of savingtargets_v01)
    Public Overridable Property m_report_base_v01 As DbSet(Of report_base_v01)

End Class