﻿Imports System.Text
Imports HHHB3.HHHB3.ViewModel
Imports MahApps.Metro.Controls.Dialogs

Public Class ucl_konto

    Private Sub dg_transactions_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles dg_transactions.SelectionChanged
        'In case selection changed fire a beginedit an the selected item.
        Dim v_trans As transactions_v01 = TryCast(dg_transactions.CurrentItem, transactions_v01)
        If Not v_trans Is Nothing Then
            v_trans.BeginEdit()
        End If


        'Passes the currently selected items to the konto.selectedobject property
        Dim v_cpres As ContentPresenter = DirectCast(DataContext, ContentPresenter)
        Dim v_konto As konto_v01 = DirectCast(v_cpres.Content, konto_v01)
        v_konto.SelectedObject = dg_transactions.SelectedItems.Cast(Of transactions_v01)().ToList


    End Sub

    Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        SetCommands()

    End Sub

    Private Sub SetCommands()
        Dim MVModel As MainViewModel = GalaSoft.MvvmLight.Ioc.SimpleIoc.Default.GetInstance(Of MainViewModel)
        If MVModel Is Nothing Then Exit Sub
        For Each v_key As String In MVModel.shortcut_keys
            If Not v_key Is Nothing OrElse v_key = "" OrElse v_key = String.Empty OrElse v_key = " " Then
                Dim cparam(1) As Object
                cparam(1) = Me.DataContext 'Datacontext is not set in this stage.....
                cparam(0) = v_key
                dg_transactions.InputBindings.Add(New KeyBinding With
                                                  {.Modifiers = ModifierKeys.Control,
                                                  .Key = KeyFromString(v_key),
                                                  .Command = MVModel.cmdTransactionsChangeStatus,
                                                  .CommandParameter = cparam})
            End If
        Next
    End Sub

    Public Function KeyFromString(theKey As String) As Key
        Dim kc As KeyConverter = New KeyConverter()
        Return CType(kc.ConvertFrom(theKey.ToLower), Key)
    End Function

    Private Sub ucl_konto_DataContextChanged(sender As Object, e As DependencyPropertyChangedEventArgs) Handles Me.DataContextChanged
        SetCommands()
    End Sub

    Private Async Sub dg_transactions_Drop(sender As Object, e As DragEventArgs) Handles dg_transactions.Drop

        If e.Data.GetDataPresent("dragData") Then
            Dim v_droprow As DataGridRow = TryFindFromPoint(Of DataGridRow)(CType(sender, UIElement), e.GetPosition(dg_transactions))
            Dim v_target_trans As transactions_v01 = DirectCast(v_droprow.DataContext, transactions_v01)
            Dim v_source As bookjournal_entry_v01 = TryCast(e.Data.GetData("dragData"), bookjournal_entry_v01)

            If v_target_trans Is Nothing Then Exit Sub
            If v_source Is Nothing Then Exit Sub

            'check if transaction state is unlinked:
            If v_target_trans.nv_journal Is Nothing Then
                'unlinked:
                'New status is selected
                Dim v_strbuilder As New StringBuilder
                v_strbuilder.AppendLine("Wollen Sie die Verknüpfung zwischen den beiden Elementen herstellen?")
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Verknüpfung anlegen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

                If result = MessageDialogResult.Affirmative Then
                    v_target_trans.BeginEdit()
                    v_target_trans.nv_journal = v_source
                    v_target_trans.journal_id = v_source.bje_id
                    v_source.BeginEdit()
                    v_source.trans_id = v_target_trans.trans_id
                    v_source.EndEdit()
                    v_target_trans.EndEdit()
                End If
                CType(Application.Current.Resources("Locator"), ViewModelLocator).MainModel.cmdSaveAll.Execute(Nothing)
            Else
                'linked
                Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                Await v_mainwindow.ShowMessageAsync("Verknüpfungsfehler", "Die selektierte Buchung ist bereits verknüpft.", MessageDialogStyle.Affirmative)
            End If
        End If
    End Sub

    Private Sub dg_transactions_DragEnter(sender As Object, e As DragEventArgs) Handles dg_transactions.DragEnter
        e.Effects = DragDropEffects.Link
    End Sub

    'Taken from: http://www.hardcodet.net/2009/03/moving-data-grid-rows-using-drag-and-drop
    Public Shared Function TryFindFromPoint(Of T As DependencyObject)(ByVal reference As UIElement, ByVal point As Point) As T
        Dim element As DependencyObject = TryCast(reference.InputHitTest(point), DependencyObject)
        If element Is Nothing Then
            Return Nothing
        ElseIf TypeOf element Is T Then
            Return CType(element, T)
        Else
            Return TryFindParent(Of T)(element)
        End If
    End Function

    Public Shared Function TryFindParent(Of T As DependencyObject)(ByVal child As DependencyObject) As T
        Dim parentObject As DependencyObject = GetParentObject(child)
        If parentObject Is Nothing Then Return Nothing
        Dim parent As T = TryCast(parentObject, T)
        If parent IsNot Nothing Then
            Return parent
        Else
            Return TryFindParent(Of T)(parentObject)
        End If
    End Function

    Public Shared Function GetParentObject(ByVal child As DependencyObject) As DependencyObject
        If child Is Nothing Then Return Nothing
        Dim contentElement As ContentElement = TryCast(child, ContentElement)
        If contentElement IsNot Nothing Then
            Dim parent As DependencyObject = ContentOperations.GetParent(contentElement)
            If parent IsNot Nothing Then Return parent
            Dim fce As FrameworkContentElement = TryCast(contentElement, FrameworkContentElement)
            Return fce?.Parent
        End If

        Return VisualTreeHelper.GetParent(child)
    End Function


End Class




'    Private Sub datagrid2_Drop(ByVal sender As Object, ByVal e As DragEventArgs)
'        If e.Data.GetDataPresent("dragData") Then
'            Dim person As Persons = TryCast(e.Data.GetData("dragData"), Persons)
'            Dim datagrid2 As DataGrid = TryCast(sender, DataGrid)
'            datagrid2.Items.Add(person.Name + person.City + person.Province + person.Age)
'        End If
'    End Sub
'End Class