﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data.Entity
Imports System.Printing
Imports System.Text

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Balancer:

        'commands:
        Public Property cmdBalancerKontoAdd As New RelayCommand(Of konto_v01)(Sub(p) BalancerKontoAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdBalancerKontoAddAll As New RelayCommand(AddressOf BalancerKontoAddAll, AddressOf BalancerKontoAddAllCanExecute)
        Public Property cmdBalancerPersonAdd As New RelayCommand(Of person_v01)(Sub(p) BalancerPersonAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdBalancerPersonAddAll As New RelayCommand(AddressOf BalancerPersonAddAll, AddressOf BalancerPersonAddAllCanExecute)
        Public Property cmdBalancerKontoRemove As New RelayCommand(Of konto_v01)(Sub(p) BalancerKontoRemove(p), Function(p) p IsNot Nothing)
        Public Property cmdBalancerPersonRemove As New RelayCommand(Of person_v01)(Sub(p) BalancerPersonRemove(p), Function(p) p IsNot Nothing)
        Public Property cmdBalancerExecute As New RelayCommand(AddressOf BalancerExecute, AddressOf BalancerCanExecute)
        Public Property cmdBalancerPrint As New RelayCommand(AddressOf BalancerPrint, Function() MenuBalancer IsNot Nothing AndAlso MenuBalancer.Results IsNot Nothing AndAlso MenuBalancer.Results.Count > 0)

        Private Sub BalancerKontoAdd(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            With MenuBalancer
                If Not .Selected_Kontos.Contains(v_konto) Then
                    .Selected_Kontos.AddNewItem(v_konto)
                    .Selected_Kontos.CommitNew()
                End If
            End With
        End Sub

        Private Sub BalancerKontoAddAll()
            With MenuBalancer
                .ClearAll(False, True)
                For Each v_konto As konto_v01 In Konten_Aktiv
                    .Selected_Kontos.AddNewItem(v_konto)
                Next
                .Selected_Kontos.CommitNew()
            End With
        End Sub

        Private Function BalancerKontoAddAllCanExecute() As Boolean
            If Konten_Aktiv Is Nothing Then Return False
            If Konten_Aktiv.Count >= 1 Then
                Return True
            Else
                Return False
            End If
        End Function

        Private Sub BalancerPersonAdd(v_person As person_v01)
            If v_person Is Nothing Then Exit Sub
            With MenuBalancer
                If Not .Selected_Persons.Contains(v_person) Then
                    .Selected_Persons.AddNewItem(v_person)
                    .Selected_Persons.CommitNew()
                End If
            End With
        End Sub

        Private Sub BalancerPersonAddAll()
            With MenuBalancer
                .ClearAll(True, False)
                For Each v_person As person_v01 In Persons_Aktiv
                    .Selected_Persons.AddNewItem(v_person)
                Next
                .Selected_Persons.CommitNew()
            End With
        End Sub

        Private Function BalancerPersonAddAllCanExecute() As Boolean
            If Persons_Aktiv Is Nothing Then Return False
            If Persons_Aktiv.Count >= 1 Then
                Return True
            Else
                Return False
            End If
        End Function

        Private Sub BalancerKontoRemove(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            MenuBalancer.Selected_Kontos.Remove(v_konto)
            MenuBalancer.Selected_Kontos.CommitEdit()
        End Sub
        Private Sub BalancerPersonRemove(v_person As person_v01)
            If v_person Is Nothing Then Exit Sub
            MenuBalancer.Selected_Persons.Remove(v_person)
            MenuBalancer.Selected_Persons.CommitEdit()
        End Sub

        Private Sub BalancerExecute()
            'Check if Kontos and Persons are selected:
            With MenuBalancer
                .Results.Clear()
                If .Selected_Kontos Is Nothing OrElse .Selected_Kontos.Count = 0 Then Exit Sub
                If .Selected_Persons Is Nothing OrElse .Selected_Persons.Count = 0 Then Exit Sub

                For Each v_person As person_v01 In .Selected_Persons
                    Dim v_result As Decimal = 0
                    For Each v_konto As konto_v01 In .Selected_Kontos
                        Debug.Print(v_person.nv_person_trans.Count.ToString)
                        v_result += v_person.nv_person_trans.Where(Function(x) x.konto_id = v_konto.kto_id AndAlso x.datum >= .Start_date AndAlso x.datum < .End_date.AddDays(1)).Sum(Function(x) x.real_totamount)
                    Next
                    .Results.Add(New person_v01_balance With {.Bezeichnung = v_person.bezeichnung, .PersonId = v_person.pers_id, .Amount = v_result, .Delta = 0})
                Next

                'Now Calculate the total amount:
                .TotAmount = .Results.Sum(Function(x) Math.Abs(x.Amount))
                .Average = .TotAmount / .Results.Count
                For Each v_personbal As person_v01_balance In .Results
                    v_personbal.Delta = Math.Abs(v_personbal.Amount) - Math.Abs(.Average)
                Next

            End With
        End Sub

        Private Sub BalancerPrint()
            'Prints the Balancer in a new flowdocument:
            Dim v_print_dia As New PrintDialog
            Dim v_print_server As New LocalPrintServer
            Dim v_print_queue As PrintQueue = v_print_server.DefaultPrintQueue
            Dim v_print_ticket As PrintTicket = v_print_queue.UserPrintTicket

            Dim v_rep_local As New FlowDocument With {.PageWidth = 1104, .ColumnGap = 0, .IsColumnWidthFlexible = True, .PageHeight = 768, .ColumnWidth = 1104}

            Dim v_rowcount As Integer = 1
            Dim v_oddrowbrush As Brush = SettingsCurrent.color_background_oddrow_brush
            Dim v_justrowbrush As Brush = SettingsCurrent.color_background_justrow_brush
            Dim v_headerbackgroundbrush As Brush = SettingsCurrent.color_background_header_brush
            Dim v_header_fontsize As Double = SettingsCurrent.header_fontsize
            Dim v_row_fontsize As Double = SettingsCurrent.row_fontsize

            Dim v_columns As New Dictionary(Of String, Integer) From {
                    New KeyValuePair(Of String, Integer)(“Person", 20),
                    New KeyValuePair(Of String, Integer)("Betrag", 30),
                    New KeyValuePair(Of String, Integer)("Abweichung", 30)}

            With v_rep_local
                'Header for a Searchdefinition
                .Blocks.Add(New Paragraph(New Run("Ergebnis für Abrechnung") With {.FontSize = v_header_fontsize}))
                'Creation Date:
                .Blocks.Add(New Paragraph(New Run(String.Format("Erstellt am {0}", Date.Now.ToShortDateString)) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Right})
                'Add the criteria of the balacner:
                'Date Frame:
                .Blocks.Add(New Paragraph(New Run(String.Format("Zeitraum: {0} bis {1}", MenuBalancer.Start_date.ToShortDateString, MenuBalancer.End_date.ToShortDateString)) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Left})
                'Selected Kontos:
                Dim v_strbuilder_konto As New StringBuilder
                If MenuBalancer.Results.Count = 1 Then
                    v_strbuilder_konto.Append("Gewähltes Konto:")
                Else
                    v_strbuilder_konto.Append("Gewählte Konten:")
                End If
                For Each v_kto As konto_v01 In MenuBalancer.Selected_Kontos
                    v_strbuilder_konto.Append(v_kto.bezeichnung_full & ";")
                Next
                .Blocks.Add(New Paragraph(New Run(v_strbuilder_konto.ToString) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Left})
                'Selected Persons:
                Dim v_strbuilder_person As New StringBuilder
                If MenuBalancer.Results.Count = 1 Then
                    v_strbuilder_person.Append("Gewählte Person:")
                Else
                    v_strbuilder_person.Append("Gewählte Personen:")
                End If
                For Each v_pers As person_v01 In MenuBalancer.Selected_Persons
                    v_strbuilder_person.Append(v_pers.bezeichnung & ";")
                Next
                .Blocks.Add(New Paragraph(New Run(v_strbuilder_person.ToString) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Left})
                'Totalamount:
                .Blocks.Add(New Paragraph(New Run(String.Format("Gesamtsumme: {0}", MenuBalancer.TotAmount.ToString("C"))) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Left})
                'Totalamount:
                .Blocks.Add(New Paragraph(New Run(String.Format("Summe pro Person soll: {0}", MenuBalancer.Average.ToString("C"))) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Left})
                .Blocks.Add(New BlockUIContainer(New Rectangle With {.Stroke = New SolidColorBrush(Colors.Black), .StrokeThickness = 3, .Height = 3, .Width = Double.NaN}))
                .Blocks.Add(New Paragraph(New Run("")))
                'Now the results:
                Dim v_results As New Grid With {.ShowGridLines = False}
                With v_results
                    'Header Row:
                    .RowDefinitions.Add(New RowDefinition)

                    For Each v_str As KeyValuePair(Of String, Integer) In v_columns
                        .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(v_str.Value, GridUnitType.Star)})
                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = v_headerbackgroundbrush}
                        Dim v_lbl As New Label With {.Content = v_str.Key, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, .ColumnDefinitions.Count - 1)
                        Grid.SetRow(v_border, 0)
                        .Children.Add(v_border)
                        v_lbl = Nothing
                    Next
                End With
                .Blocks.Add(New BlockUIContainer(v_results))
                For Each v_result As person_v01_balance In MenuBalancer.Results
                    Dim v_res_pers As New Grid With {.ShowGridLines = False}
                    With v_res_pers
                        For Each v_str As KeyValuePair(Of String, Integer) In v_columns
                            .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(v_str.Value, GridUnitType.Star)})
                        Next

                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl As New Label With {.Content = v_result.Bezeichnung, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, 0)
                        Grid.SetRow(v_border, 0)
                        .Children.Add(v_border)
                        v_lbl = Nothing

                        Dim v_border_amount As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_amount As New Label With {.Content = v_result.Amount.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center}
                        v_border_amount.Child = v_lbl_amount
                        Grid.SetColumn(v_border_amount, 1)
                        Grid.SetRow(v_border_amount, 0)
                        .Children.Add(v_border_amount)
                        v_lbl_amount = Nothing

                        Dim v_border_delta As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_delta As New Label With {.Content = v_result.Delta.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center}
                        v_border_delta.Child = v_lbl_delta
                        Grid.SetColumn(v_border_delta, 2)
                        Grid.SetRow(v_border_delta, 0)
                        .Children.Add(v_border_delta)
                        v_lbl_delta = Nothing

                    End With
                    .Blocks.Add(New BlockUIContainer(v_res_pers))
                    v_rowcount += 1
                Next
                'Info text:
                .Blocks.Add(New Paragraph(New Run("Hinweis: Personen mit negativer Abweichung müssen zum Ausgleich diese Summe an die anderen Personen anteilig bezahlen.") With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Left})
            End With

            Dim v_pm_size As PageMediaSize = New PageMediaSize(v_rep_local.PageWidth, v_rep_local.PageHeight)
            v_print_ticket.PageMediaSize = v_pm_size
            v_print_ticket.PageOrientation = PageOrientation.Landscape

            Dim v_docpag As IDocumentPaginatorSource = TryCast(v_rep_local, IDocumentPaginatorSource)

            If v_docpag Is Nothing Then
                cls_logger.v_logger.Error("Umwandlung von Balancer Report in Paginator failed")
                Exit Sub
            End If

            Dim v_imageablearea As System.Printing.PrintDocumentImageableArea = Nothing
            Dim v_docwriter As System.Windows.Xps.XpsDocumentWriter = System.Printing.PrintQueue.CreateXpsDocumentWriter(v_imageablearea)

            v_docpag.DocumentPaginator.ComputePageCount()
            Dim paginator As DocumentPaginator = v_docpag.DocumentPaginator
            paginator = New DocumentPaginatorWrapper(v_docpag.DocumentPaginator, New Size(1104, 768), New Size(20, 45))

            If v_docwriter IsNot Nothing AndAlso v_imageablearea IsNot Nothing Then
                v_docwriter.Write(paginator, v_print_ticket)
            End If

            'Dim v_pm_size As PageMediaSize = New PageMediaSize(v_rep_local.PageWidth, v_rep_local.PageHeight)
            'v_print_ticket.PageMediaSize = v_pm_size
            'v_print_ticket.PageOrientation = PageOrientation.Landscape

            'Dim v_docpag As IDocumentPaginatorSource = TryCast(v_rep_local, IDocumentPaginatorSource)

            'If v_docpag Is Nothing Then
            '    cls_logger.v_logger.Error("Umwandlung von Balancer Report in Paginator failed")
            '    Exit Sub
            'End If

            'Dim v_imageablearea As System.Printing.PrintDocumentImageableArea = Nothing
            'Dim v_docwriter As System.Windows.Xps.XpsDocumentWriter = System.Printing.PrintQueue.CreateXpsDocumentWriter(v_imageablearea)

            'v_docpag.DocumentPaginator.ComputePageCount()
            'Dim paginator As DocumentPaginator = v_docpag.DocumentPaginator
            'paginator = New DocumentPaginatorWrapper(v_docpag.DocumentPaginator, New Size(1104, 768), New Size(20, 45))

            'If v_docwriter IsNot Nothing AndAlso v_imageablearea IsNot Nothing Then
            '    v_docwriter.Write(paginator, v_print_ticket)
            'End If
        End Sub

        Private Function BalancerCanExecute() As Boolean
            'Balancer can only be executed when at least 1 Konto or 1 Person is selected
            With MenuBalancer
                If .Selected_Kontos.Count >= 1 AndAlso .Selected_Persons.Count >= 1 Then
                    Return True
                Else
                    Return False
                End If
            End With

        End Function


    End Class
End Namespace
