﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data.Entity
Imports System.Globalization
Imports System.IO
Imports System.Text
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Class for Commands of entity Bookingjournal

        'Tuple which holds possible locations for columns:
        Public Property ImportColumns As New List(Of Tuple(Of String, String))
        Public Property GroupSeparators As New List(Of String) From {".", ","}
        Public Property Textqualifier As New List(Of String) From {"""", "'"}

        'Importdefinitions abailable:
        Private WithEvents __bj_import_definitions As New ObservableCollection(Of bookjournal_import_definition_v01)
        Private WithEvents __bookjournalentries As New ObservableCollection(Of bookjournal_entry_v01)

        Public Property BJImportDefintions As ListCollectionView

        Private Sub BookingJournalLoad()
            __bookjournalentries.Clear()
            dbo.m_bookjournal_entry_v01.Load
            __bookjournalentries = dbo.m_bookjournal_entry_v01.Local
            Call SetBJImportColumns()
            __bj_import_definitions.Clear()
            dbo.m_bookjournal_import_definition_v01.Load
            __bj_import_definitions = dbo.m_bookjournal_import_definition_v01.Local
            BJImportDefintions = New ListCollectionView(__bj_import_definitions)
        End Sub

        Private Sub SetBJImportColumns()
            With ImportColumns
                If Not ImportColumns Is Nothing Then .Clear()
                .Add(New Tuple(Of String, String)("Status", "status_str"))
                .Add(New Tuple(Of String, String)("Typ", "typ_str"))
                .Add(New Tuple(Of String, String)("Konto", "konto_str"))
                .Add(New Tuple(Of String, String)("zu Konto", "to_konto_str"))
                If SettingsCurrent.active_receiver Then .Add(New Tuple(Of String, String)("Empfänger", "receiver_str"))
                If SettingsCurrent.active_person Then .Add(New Tuple(Of String, String)("Person", "person_str"))
                If SettingsCurrent.active_tags Then .Add(New Tuple(Of String, String)("Tag", "tag_str"))
                .Add(New Tuple(Of String, String)("Kategorie", "category_str"))
                .Add(New Tuple(Of String, String)("Bemerkung", "note_str"))
                .Add(New Tuple(Of String, String)("Datum", "datum"))
                .Add(New Tuple(Of String, String)("Betrag", "value"))
                .Add(New Tuple(Of String, String)("Ignorieren", "ignore"))
            End With
        End Sub

        Private Sub __bj_import_definitions_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __bj_import_definitions.CollectionChanged
            If Not BJImportDefintions Is Nothing Then
                If Not BJImportDefintions.MoveCurrentToNext Then BJImportDefintions.MoveCurrentToPrevious()
            End If
        End Sub

        'commands for import:
        Public Property cmdImportNew As New RelayCommand(Of bookjournal_v01)(Sub(p) ImportNew(p), Function(p) p IsNot Nothing)
        Public Property cmdImportGetFile As New RelayCommand(Of bookjournal_v01)(Sub(p) ImportGetFile(p), Function(p) p IsNot Nothing)
        Public Property cmdImportDoPreview As New RelayCommand(Of bookjournal_v01)(Sub(p) ImportDoPreview(p), Function(p) ImportDoPreviewCanExecute(p))
        Public Property cmdImportDoAssigned As New RelayCommand(Of bookjournal_v01)(Sub(p) ImportDoAssigned(p), Function(p) ImportDoAssignedCanExecute(p))

        'Importdefinition Commands:
        Public Property cmdImportDefinitionSave As New RelayCommand(Of bookjournal_v01)(Sub(p) ImportDefinitionSave(p), Function(p) ImportDefinitionSaveCanExecute(p))
        Public Property cmdImportDefinitionLoad As New RelayCommand(Of Object())(Sub(p) ImportDefinitionLoad(p), Function(p) ImportDefinitionLoadCanExecute(p))

        'Validation Commands:
        Public Property cmdImportDoValidation As New RelayCommand(Of bookjournal_v01)(Sub(p) ImportDoValidation(p), Function(p) ImportDoValidationCanExecute(p))
        Public Property cmdImportDo As New RelayCommand(Of bookjournal_v01)(Sub(p) ImportDo(p), Function(p) ImportDoCanExecute(p))

        Public Property cmdJournalOpenTrans As New RelayCommand(Of bookjournal_entry_v01)(Sub(p) JournalOpenTransOrLinkTrans(p), Function(p) JournalOpenTransOrLinkTransCanExecute(p))
        Public Property cmdJournalLink As New RelayCommand(Of bookjournal_v01)(Sub(p) JournalLink(p), Function(p) JournalLinkCanExecute(p))
        Public Property cmdJournalLinkRemove As New RelayCommand(Of bookjournal_v01)(Sub(p) JournalLinkRemove(p), Function(p) JournalEntriesDeleteCanExecute(p))
        Public Property cmdJournalUnlink As New RelayCommand(Of transactions_v01)(Sub(p) JournalUnlink(p), Function(p) JournalUnlinkCanExecute(p))
        Public Property cmdJournalCreateTransaction As New RelayCommand(Of bookjournal_v01)(Sub(p) JournalCreateTransaction(p), Function(p) JournalCreateTransactionCanExecute(p))

        Public Property cmdJournalEntriesDelete As New RelayCommand(Of bookjournal_v01)(Sub(p) JournalEntriesDelete(p), Function(p) JournalEntriesDeleteCanExecute(p))

        Public Property cmdJournalFilter As New RelayCommand(Of Object())(Sub(p) JournalFilter(p), Function(p) JournalFilterCanExecute(p))

        'Public Property cmdJournalShowLinkedOnly As New RelayCommand(Of Object())(Sub(p) JournalShowLinkedOnly(p), Function(p) JournalShowLinkedOnlyCanExcute(p))

        Private Sub ImportNew(v_journal As bookjournal_v01)
            Dim v_dia As New frm_import_journal_csv With {.DataContext = v_journal}
            With v_dia
                .ShowDialog()

            End With
        End Sub

        Private Sub ImportGetFile(v_journal As bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub
            'Get File Dialog:
            Dim objDialog As New Forms.OpenFileDialog With {.DefaultExt = ".csv", .Filter = "CSV Datei (*.csv)|*.csv|Excel Datei (*.xlsx)|*.xlsx|Excel Datei alt (*.xls)|*.xls|Quicken 2008 (*.qif08)|*.qif08"}

            Dim objResult As Forms.DialogResult = objDialog.ShowDialog
            If objResult = Forms.DialogResult.OK Then
                v_journal.FilePath = objDialog.FileName
                If v_journal.FilePath = Nothing OrElse v_journal.FilePath = String.Empty Then
                    Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
                    vMainWindow.ShowMessageAsync("Fehler", "Datei konnte nicht gefunden werden", MessageDialogStyle.Affirmative)
                    Exit Sub
                End If
            Else
                Exit Sub
            End If
        End Sub

        Private Sub ImportDoPreview(v_journal As bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub
            If v_journal.FilePath = Nothing OrElse v_journal.FilePath = String.Empty Then Exit Sub

            If System.IO.File.Exists(v_journal.FilePath) Then
                'Depending on the type of the file select what to do:
                Select Case System.IO.Path.GetExtension(v_journal.FilePath)
                    Case ".csv"
                        With v_journal
                            Dim v_temp As String() = File.ReadAllLines(v_journal.FilePath)
                            If Not .RawData Is Nothing Then .RawData.Clear()
                            If Not .RawData_Columns Is Nothing Then .RawData_Columns.Clear()

                            'Columns:
                            Dim v_columns As String() = v_temp.First.Split(.csv_limiter)
                            For Each v_item As String In v_columns
                                '.RawData_Columns.Add(New Tuple(Of String, String) From {v_item, ""})
                                '.RawData_Columns.Add(New Tuple(Of String, String)(v_item, ""))
                                .RawData_Columns.Add(New cls_search_column_helper With {.ColnameImport = v_item, .ColnameSelected = String.Empty})
                            Next

                            'Now the entries
                            Dim i As Integer = 0
                            For Each v_item As String In v_temp
                                If i = 0 Then
                                    i += 1
                                    Continue For
                                Else
                                    .RawData.Add(v_item)
                                End If
                            Next

                            v_temp = Nothing
                        End With

                    Case ".xlsx", ".xls", ".xlsm"
                        'not supported right now
                    Case ".qif08"
                        'not supported right now
                End Select

            Else
                Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
                vMainWindow.ShowMessageAsync("Fehler", "Datei konnte nicht gefunden werden", MessageDialogStyle.Affirmative)
                Exit Sub
            End If

        End Sub

        Private Function ImportDoPreviewCanExecute(v_journal As bookjournal_v01) As Boolean
            If v_journal Is Nothing Then Return False
            If v_journal.FilePath = Nothing OrElse v_journal.FilePath = String.Empty Then Return False
            If System.IO.File.Exists(v_journal.FilePath) Then Return True
            Return True
        End Function

        Private Sub ImportDoAssigned(v_journal As bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub
            'Assign the Rawdata according to the columndefinition to a typed entry:
            'Import the assigned data to a temporary list befor adding to the journal in database:
            'check for duplicates in the column (except empty or ignore values)
            Dim v_dblcheck_1 As Integer = v_journal.RawData_Columns.Where(Function(x) x.ColnameSelected <> "ignore" OrElse x.ColnameSelected <> "").Distinct.Count
            Dim v_dblcheck_2 As Integer = v_journal.RawData_Columns.Where(Function(x) x.ColnameSelected <> "ignore" OrElse x.ColnameSelected <> "").Count
            If v_dblcheck_1 < v_dblcheck_2 Then
                Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
                vMainWindow.ShowMessageAsync("Fehler", "Spaltenzuordnung enthält Duplikate. Bitte korrigieren.", MessageDialogStyle.Affirmative)
                Exit Sub
            End If


            Dim v_temp_entries As New ObservableCollection(Of bookjournal_entry_v01)
            For Each v_item As String In v_journal.RawData
                Dim v_bje As New bookjournal_entry_v01
                'Split with limiter:
                Dim v_item_split As String() = v_item.Split(v_journal.csv_limiter)
                'Now go through Items:
                For i As Integer = 0 To v_item_split.Count - 1
                    Dim v_col As cls_search_column_helper = v_journal.RawData_Columns(i)
                    Select Case v_col.ColnameSelected
                        Case "status_str"
                            v_bje.status_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "typ_str"
                            v_bje.typ_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "konto_str"
                            v_bje.konto_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "to_konto_str"
                            v_bje.to_konto_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "receiver_str"
                            v_bje.receiver_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "person_str"
                            v_bje.person_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "tag_str"
                            v_bje.tag_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "category_str"
                            v_bje.category_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "note_str"
                            v_bje.note_str = v_item_split(i).Replace(v_journal.csv_textqualifier, "")
                        Case "datum"
                            v_bje.datum = Date.Parse(v_item_split(i).Replace(v_journal.csv_textqualifier, ""))
                        Case "value"
                            Dim v_cleanstring As String = v_item_split(i).Replace(v_journal.csv_textqualifier, "").Replace(v_journal.csv_groupseparator, "")
                            v_bje.value = CDec(Double.Parse(v_cleanstring))
                            'Other Cases will be ignored e.g. ignore or empty entries
                    End Select
                Next
                v_temp_entries.Add(v_bje)
                v_bje = Nothing
            Next
            v_journal.BookjournalEntriesTemp.Clear()

            v_journal.BookjournalEntriesTemp = v_temp_entries
            v_temp_entries = Nothing
            'Prüfen auf Duplicate und dann entsprechend einen Wahrscheinlichkeitsindex ermitteln
            'Hinzufügen eines "ignore" markers beim importieren
            'Abspeichern der Spaltendefinition und laden...

        End Sub

        Private Function ImportDoAssignedCanExecute(v_journal As bookjournal_v01) As Boolean
            If v_journal Is Nothing Then Return False
            With v_journal
                If .RawData_Columns Is Nothing Then Return False
                If .RawData Is Nothing Then Return False
                If .csv_limiter Is Nothing Then Return False
                If .csv_limiter = String.Empty Then Return False
            End With
            Return True
        End Function

        Private Async Sub ImportDefinitionSave(v_journal As bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub
            If v_journal.RawData_Columns Is Nothing Then Exit Sub
            If v_journal.RawData_Columns.Count = 0 Then Exit Sub

            Dim v_new_definition As New bookjournal_import_definition_v01 With {.csv_comma_sep = ",",
                .csv_textqualifier = v_journal.csv_textqualifier,
                .csv_thousand_sep = v_journal.csv_groupseparator}

            For Each v_item As cls_search_column_helper In v_journal.RawData_Columns
                v_new_definition.import_definition_entries.Add(New bookjournal_import_definition_entry_v01 With {.name_import = v_item.ColnameImport, .name_selected = v_item.ColnameSelected})
            Next
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            v_new_definition.bezeichnung = Await vMainWindow.ShowInputAsync("Bezeichnung", "Geben Sie eine Bezeichnung für die Import Definition ein:")

            BJImportDefintions.AddNewItem(v_new_definition)
            BJImportDefintions.CommitNew()

            dbo.SaveChanges()

        End Sub

        Private Function ImportDefinitionSaveCanExecute(v_journal As bookjournal_v01) As Boolean
            If v_journal Is Nothing Then Return False
            If v_journal.RawData_Columns Is Nothing Then Return False
            If v_journal.RawData_Columns.Count = 0 Then Return False
            Return True
        End Function

        Private Sub ImportDefinitionLoad(v_obj As Object())
            If v_obj Is Nothing Then Exit Sub
            Dim v_journal As bookjournal_v01 = TryCast(v_obj(0), bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub
            Dim v_definition As bookjournal_import_definition_v01 = TryCast(v_obj(1), bookjournal_import_definition_v01)
            If v_definition Is Nothing Then Exit Sub
            Dim v_found As Integer = 0

            'Now load the definition and compare with the RawDataColumns:
            For Each v_item As cls_search_column_helper In v_journal.RawData_Columns
                Dim v_foundentry As bookjournal_import_definition_entry_v01 = v_definition.import_definition_entries.Where(Function(x) x.name_import = v_item.ColnameImport).First
                If v_foundentry IsNot Nothing Then
                    v_found += 1
                    v_item.ColnameSelected = v_foundentry.name_selected
                End If
                v_foundentry = Nothing
            Next

            'Qualifiers and the rest:
            With v_journal
                .csv_groupseparator = v_definition.csv_thousand_sep
                .csv_textqualifier = v_definition.csv_textqualifier
                .ignore_duplicates_possible = v_definition.ignore_duplicates_possible
            End With

            If Not v_found = v_journal.RawData_Columns.Count Then
                'The amount of found columns is not the same then the amount of RawDataColumns seems that the file is not fitting the definition:
                Dim v_text As String = "Die Anzahl der gefundenen Spalten ({0}) entspricht nicht der Anzahl der in der Datei gefundenen ({1})."
                Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
                vMainWindow.ShowMessageAsync("Hinweis", String.Format(v_text, v_found.ToString, v_journal.RawData_Columns.Count.ToString), MessageDialogStyle.Affirmative)
            End If

        End Sub

        Private Function ImportDefinitionLoadCanExecute(v_obj As Object()) As Boolean
            If v_obj Is Nothing Then Return False
            'First ITem is bookjournal
            Dim v_journal As bookjournal_v01 = TryCast(v_obj(0), bookjournal_v01)
            If v_journal Is Nothing Then Return False
            If v_journal.RawData_Columns Is Nothing Then Return False
            If v_journal.RawData_Columns.Count = 0 Then Return False
            If TryCast(v_obj(1), bookjournal_import_definition_v01) Is Nothing Then Return False
            Return True
        End Function

        Private Sub ImportDoValidation(v_journal As bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub

            Dim vSetTypIfEmpty As Boolean = True
            Dim vSetKontoIfEmpty As Boolean = True

            'Compare the existing journal entries with the new entries and check if they are duplicates.
            For Each v_item As bookjournal_entry_v01 In v_journal.BookjournalEntriesTemp
                v_item.reset_state()
                'Check if possible duplicate:
                'case 1 datum and value are the same probaility of an duplicate is pretty high:
                If v_journal.bookjournal_entries.Where(Function(x) x.datum = v_item.datum AndAlso x.value = v_item.value).Count > 0 Then
                    v_item.validation_status = 1
                    v_item.duplicate_propability = 0.66
                End If
                'case 2 comment is the same
                If v_journal.bookjournal_entries.Where(Function(x) x.note_str = v_item.note_str).Count > 0 Then
                    v_item.validation_status = 1
                    v_item.duplicate_propability += 0.33
                End If
                'case 3 all values match
                If v_journal.bookjournal_entries.Where(Function(x) x.datum = v_item.datum AndAlso x.value = v_item.value AndAlso x.note_str = v_item.note_str).Count > 0 Then
                    v_item.validation_status = 2
                    v_item.duplicate_propability = 1
                End If

                If vSetTypIfEmpty Then
                    If String.IsNullOrEmpty(v_item.typ_str) Then
                        Select Case v_item.value
                            Case 0
                                v_item.typ_str = "transfer"
                            Case < 0
                                v_item.typ_str = "aus"
                            Case > 0
                                v_item.typ_str = "ein"
                        End Select
                    End If
                End If

                If vSetKontoIfEmpty Then
                    If String.IsNullOrEmpty(v_item.konto_str) Then
                        v_item.konto_str = v_journal.nv_konto_back.kto_id.ToString
                    End If
                End If

                'After check set to no duplicate if validation_status is still 0
                If v_item.validation_status = 0 Then v_item.validation_status = 3
            Next
            v_journal.can_import_start = True
        End Sub

        Private Function ImportDoValidationCanExecute(v_journal As bookjournal_v01) As Boolean
            If v_journal Is Nothing Then Return False
            With v_journal
                If .RawData_Columns Is Nothing Then Return False
                If .RawData_Columns.Count = 0 Then Return False
                If .BookjournalEntriesTemp Is Nothing Then Return False
                If .BookjournalEntriesTemp.Count = 0 Then Return False
            End With
            Return True
        End Function

        Private Async Sub ImportDo(v_journal As bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub

            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine(String.Format("Wollen Sie {0} neue Einträge dem Buchungsjournal hinzufügen?", v_journal.BookjournalEntriesTemp.Count))
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_window As MahApps.Metro.Controls.MetroWindow = Application.Current.Windows.OfType(Of MahApps.Metro.Controls.MetroWindow).FirstOrDefault(Function(x) x.IsActive)
            Dim result As MessageDialogResult = Await v_window.ShowMessageAsync("Import durchführen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)


            If result = MessageDialogResult.Affirmative Then
                Dim v_prgdiacont As ProgressDialogController = Await v_window.ShowProgressAsync("Import durchführen", "Import wird durchgeführt...")
                Dim i As Integer = 0
                v_prgdiacont.Minimum = 0
                v_prgdiacont.Maximum = v_journal.BookjournalEntriesTemp.Count
                v_prgdiacont.SetProgress(i)
                For Each v_item As bookjournal_entry_v01 In v_journal.BookjournalEntriesTemp
                    'Check if it's not a duplicate:
                    If v_item.validation_status = 3 Then
                        v_journal.bookjournal_entries.Add(v_item)
                    ElseIf v_item.validation_status = 1 Then
                        If Not v_journal.ignore_duplicates_possible Then
                            v_journal.bookjournal_entries.Add(v_item)
                        End If
                    End If
                    i += 1
                    v_prgdiacont.SetProgress(i)
                Next
                Await v_prgdiacont.CloseAsync
                v_journal.reset_import()
                dbo.SaveChanges()
                v_window.Close()
            End If
        End Sub

        Private Function ImportDoCanExecute(v_journal As bookjournal_v01) As Boolean
            If v_journal Is Nothing Then Return False
            If v_journal.BookjournalEntriesTemp Is Nothing Then Return False
            If v_journal.BookjournalEntriesTemp.Count = 0 Then Return False
            Return v_journal.can_import_start
        End Function

        Private Sub JournalOpenTransOrLinkTrans(v_journal_entry As bookjournal_entry_v01)
            If v_journal_entry Is Nothing Then Exit Sub
            If v_journal_entry.nv_transaction Is Nothing Then
                'Entry is not linked.
                'Call Window for Linking Action:

            Else
                'Call Edit Command:
                TransactionEdit(v_journal_entry.nv_transaction)
            End If
        End Sub

        Private Function JournalOpenTransOrLinkTransCanExecute(v_journal_entry As bookjournal_entry_v01) As Boolean
            If v_journal_entry Is Nothing Then Return False
            If v_journal_entry.nv_transaction Is Nothing Then Return False
            Return True
        End Function

        ''' <summary>
        ''' Trys to link all unlinked journal entries with a corresponding transaction
        ''' </summary>
        ''' <param name="v_journal"></param>
        Private Async Sub JournalLink(v_journal As bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub
            If v_journal.SelectedObjects Is Nothing Then Exit Sub
            If v_journal.SelectedObjects.Count = 0 Then Exit Sub
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim v_unlinked_count As Integer = v_journal.SelectedObjects.Where(Function(x) x.nv_transaction Is Nothing).Count
            If v_unlinked_count = 0 Then
                Await vMainWindow.ShowMessageAsync("Fehler", "Alle gewählten Elemente sind bereits verknüpft.", MessageDialogStyle.Affirmative)
                Exit Sub
            End If
            'New status is selected
            Dim v_strbuilder As New StringBuilder
            If v_journal.SelectedObjects.Count = 1 Then
                v_strbuilder.AppendLine("Sollen für das gewählte Element die Verknüpfung zu einer bestehenden Buchung hergestellt werden?")
            Else
                v_strbuilder.AppendLine(String.Format("Es sind {0} von {1} gewählte Einträge nicht verknüpft.", v_unlinked_count, v_journal.SelectedObjects.Count))
                v_strbuilder.AppendLine("Sollen für diese Elemente die Verknüpfungen zu bestehenden Buchungen hergestellt werden?")
            End If

            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}

            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Verknüpfen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            Dim v_prgmsg As ProgressDialogController

            Dim v_progress As Double = 0
            Dim v_possible_link_count As Integer = 0
            Dim v_possible_new As Integer = 0
            If result = MessageDialogResult.Affirmative Then
                v_prgmsg = Await vMainWindow.ShowProgressAsync("Journal verknüpfen", "Mögliche Verknüpfungen werden ermittelt.")
                v_prgmsg.Maximum = v_journal.SelectedObjects.Count
                v_prgmsg.Minimum = 0
                Dim v_konto As konto_v01 = v_journal.nv_konto_back
                Dim v_transactions As ObservableCollection(Of transactions_v01) = v_konto.nv_kto_2_trans

                For Each v_entry As bookjournal_entry_v01 In v_journal.SelectedObjects
                    If v_entry.nv_transaction Is Nothing Then
                        'Not linked:
                        If v_transactions.Where(Function(x) x.datum = v_entry.datum And x.real_totamount = v_entry.value And x.nv_journal Is Nothing).Count = 1 Then
                            'Possible Link found
                            v_entry.possible_link_id = v_transactions.Where(Function(x) x.datum = v_entry.datum And x.real_totamount = v_entry.value And x.nv_journal Is Nothing).First.trans_id
                            v_entry.possible_link = True
                            v_possible_link_count += 1
                        Else
                            'Nothing found
                            'Add a new transaction or set state and display a new window with the results.
                            v_entry.possible_link = False
                            v_possible_new += 1
                        End If

                    End If
                    v_progress += 1
                    v_prgmsg.SetProgress(v_progress)
                Next
                Await v_prgmsg.CloseAsync
            End If
            result = Await vMainWindow.ShowMessageAsync("Prüfungsergebnis", String.Format("Prüfung abgeschlossen. Es wurden {0} mögliche Verknüpfungen und {1} neue Buchungen gefunden", v_possible_link_count, v_possible_new), MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            v_progress = 0
            Dim v_new_trans As New List(Of bookjournal_entry_v01)
            If result = MessageDialogResult.Affirmative Then

                v_prgmsg = Await vMainWindow.ShowProgressAsync("Journal verknüpfen", "Ermittelte Buchungen werden verknüpft oder es wird eine neue Buchung erstellt.")
                v_prgmsg.Maximum = v_journal.SelectedObjects.Count
                v_prgmsg.Minimum = 0
                For Each v_entry As bookjournal_entry_v01 In v_journal.SelectedObjects
                    If v_entry.nv_transaction Is Nothing Then
                        If v_entry.possible_link Then
                            'Link it
                            Dim v_trans As transactions_v01 = __transactions.Where(Function(x) x.trans_id = v_entry.possible_link_id).FirstOrDefault
                            If Not v_trans Is Nothing Then
                                v_trans.BeginEdit()
                                v_trans.nv_journal = v_entry
                                v_trans.EndEdit()
                                dbo.ChangeTracker.DetectChanges()
                                dbo.SaveChanges()
                            End If
                        Else
                            'create new transactions
                            v_new_trans.Add(v_entry)
                        End If
                    End If
                    'dbo.SaveChanges()
                    v_progress += 1
                    v_prgmsg.SetProgress(v_progress)
                Next

                'We use the JournalCreateTransactionCommand for adding new transactions:
                If v_new_trans IsNot Nothing AndAlso v_new_trans.Count > 0 Then JournalCreateTransactionBulk(v_new_trans)

                Await v_prgmsg.CloseAsync
            End If
        End Sub

        Private Function JournalLinkCanExecute(v_journal As bookjournal_v01) As Boolean
            If v_journal Is Nothing Then Return False
            If v_journal.SelectedObjects Is Nothing Then Return False
            If v_journal.SelectedObjects.Count = 0 Then Return False
            If v_journal.SelectedObjects.Where(Function(x) x.nv_transaction Is Nothing).Count = 0 Then Return False 'alle Items are linked
            Return True
        End Function

        ''' <summary>
        ''' Used to make a bulk of trans_stack transactions for newly added booking journals
        ''' </summary>
        ''' <param name="v_entries"></param>
        Private Sub JournalCreateTransactionBulk(v_entries As IList(Of bookjournal_entry_v01))
            If v_entries Is Nothing OrElse v_entries.Count = 0 Then Exit Sub
            JournalCreateTransactionDo(v_entries)
        End Sub

        ''' <summary>
        ''' Used to make a bulk of trans_stack manually by selected items
        ''' </summary>
        ''' <param name="v_journal"></param>
        Private Async Sub JournalCreateTransaction(v_journal As bookjournal_v01)
            If v_journal Is Nothing OrElse v_journal.SelectedObjects Is Nothing OrElse v_journal.SelectedObjects.Count = 0 Then Exit Sub

            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie für folgende Journaleinträge Buchungen anlegen?")
            v_strbuilder.AppendLine(String.Format("Aktion / Datum / Betrag"))
            For Each v_item As bookjournal_entry_v01 In v_journal.SelectedObjects
                v_strbuilder.AppendLine(String.Format("{0} / {1} / {2}", If(v_item.nv_transaction Is Nothing, "Anlegen", "Ignorieren"), v_item.datum.ToShortDateString, String.Format(v_item.value.ToString, "2C")))
            Next
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MainWindow = DirectCast(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Buchungen anlegen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result = MessageDialogResult.Affirmative Then
                JournalCreateTransactionDo(v_journal.SelectedObjects)
            End If
        End Sub

        Private Sub JournalCreateTransactionDo(v_object As IList(Of bookjournal_entry_v01))
            If v_object Is Nothing OrElse v_object.Count = 0 Then Exit Sub

            For Each v_item As bookjournal_entry_v01 In v_object
                If v_item.nv_transaction Is Nothing Then
                    Dim v_abort As Boolean = False
                    'Before adding the entry to the StackTransactions Stack check if it's is not existing:
                    For Each v_entry In StackTransactions.StackTransactions
                        'Necessary to avoid error with new item placeholder
                        If TypeOf v_entry Is transactions_stack Then
                            If DirectCast(v_entry, transactions_stack).cont_transaction.nv_journal.bje_id = v_item.bje_id Then
                                v_abort = True
                                ' Exit Sub
                            End If
                        End If
                    Next
                    If v_abort Then Continue For
                    'When value of entry is negative then outgoing transaction otherwise incoming:
                    Dim v_search As String = ""
                    If v_item.value < 0 Then
                        v_search = "aus"
                    Else
                        v_search = "ein"
                    End If
                    StackTransactions.StackTransactions.AddNewItem(New transactions_stack With {.cont_amount = Math.Abs(v_item.value)})
                    Dim v_tstack As transactions_stack = CType(StackTransactions.StackTransactions.CurrentAddItem, transactions_stack)
                    If v_tstack Is Nothing Then Throw New Exception("Fehler beim erzeugen einer Buchung")
                    With v_tstack
                        'Tag
                        If Not v_item.tag_str = String.Empty Then
                            Dim v_tag_id As Integer = __tags.Where(Function(x) x.bezeichnung.ToLower Like v_item.tag_str.ToLower).First.tag_id
                            If Not v_tag_id = Nothing Then .cont_tag_id = v_tag_id
                        End If
                        'Category
                        If Not v_item.category_str = String.Empty Then
                            Dim v_category_id As Integer = __categories.Where(Function(x) x.bezeichnung.ToLower Like v_item.category_str.ToLower).First.cat_id
                            If Not v_category_id = Nothing Then .cont_category_id = v_category_id
                        End If

                        If .cont_category_id = 0 Then .cont_category_id = __categories.First.cat_id

                    End With
                    Dim v_trans As transactions_v01 = TryCast(v_stacktransactions.StackTransactions.CurrentAddItem, transactions_stack).cont_transaction
                    'It's necessary to edit the transaction contained in the StackTransactions collection after the creation because presets will be set during creation and will overwrite preset values!
                    If v_trans Is Nothing Then Throw New Exception("Fehler beim erzeugen einer Buchung")
                    With v_trans
                        .BeginEdit()
                        .datum = v_item.datum
                        .comment = v_item.note_str
                        .journal_id = v_item.bje_id
                        .nv_journal = v_item
                        .konto_id = v_item.nv_bookjournal_back.nv_konto_back.kto_id
                        .transtyp_id = __typen.Where(Function(x) x.internal_name = v_search).FirstOrDefault.typ_id
                        v_search = Nothing
                        'Optionals.
                        'the optionals are stored as named items in the journal they have to been searched in DB by string and will return a id if found:
                        'Receiver
                        If Not v_item.receiver_str = String.Empty Then
                            Dim v_rec_id As Integer = __reveicer.Where(Function(x) x.bezeichnung.ToLower Like v_item.receiver_str.ToLower).First.rec_id
                            If Not v_rec_id = Nothing Then .receiver_id = v_rec_id
                        End If
                        'Person
                        If Not v_item.person_str = String.Empty Then
                            Dim v_pers_id As Integer = __persons.Where(Function(x) x.bezeichnung.ToLower Like v_item.person_str.ToLower).First.pers_id
                            If Not v_pers_id = Nothing Then .person_id = v_pers_id
                        End If
                        'Status
                        If Not v_item.status_str = String.Empty Then
                            Dim v_status_id As Integer = __status.Where(Function(x) x.bezeichnung.ToLower Like v_item.status_str.ToLower).First.status_id
                            If Not v_status_id = Nothing Then .transstatus_id = v_status_id
                        End If
                        .EndEdit()
                    End With
                    StackTransactions.StackTransactions.CommitNew()
                End If
            Next
            'Open the MenuTransStack only if Items are added and it's state is closed:
            If MenuTransStack.IsClosed Then
                MenuAdd(MenuTransStack)
            Else
                MenuCurrentObject = MenuTransStack
            End If
        End Sub

        Private Function JournalCreateTransactionCanExecute(v_journal As bookjournal_v01) As Boolean
            If v_journal Is Nothing Then Return False
            If v_journal.SelectedObjects Is Nothing Then Return False
            If v_journal.SelectedObjects.Count = 0 Then Return False
            'Check if only 1 item and if the state is ready for execution (just an Eyecandy stuff)
            If v_journal.SelectedObjects.Count = 1 Then
                If v_journal.SelectedObjects.First.nv_transaction IsNot Nothing Then Return False
            End If
            Return True
        End Function

        Private Async Sub JournalLinkRemove(v_journal As bookjournal_v01)
            Dim v_question As String
            If v_journal Is Nothing Then Exit Sub
            With v_journal
                If .SelectedObjects Is Nothing Then Exit Sub
                If .SelectedObjects.Count = 0 Then Exit Sub
                If .SelectedObjects.Count = 1 Then
                    v_question = "Wollen Sie die Verknüpfung des gewählten Journaleintrages entfernen?"
                Else
                    v_question = String.Format("Wollen Sie die Verknüpfungen der gewählten {0} Journaleinträge entfernen?", .SelectedObjects.Count)
                End If
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
                Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Löschvorgang bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

                If result = MessageDialogResult.Affirmative Then
                    For Each v_item As bookjournal_entry_v01 In .SelectedObjects
                        With v_item
                            .BeginEdit()
                            .nv_transaction = Nothing
                            .trans_id = Nothing
                            .EndEdit()
                        End With
                    Next
                    dbo.SaveChanges()
                End If
            End With
        End Sub

        Private Async Sub JournalEntriesDelete(v_journal As bookjournal_v01)
            Dim v_question As String
            If v_journal Is Nothing Then Exit Sub
            With v_journal
                If .SelectedObjects Is Nothing Then Exit Sub
                If .SelectedObjects.Count = 0 Then Exit Sub
                If .SelectedObjects.Count = 1 Then
                    v_question = "Wollen Sie den gewählten Journaleintrag löschen?"
                Else
                    v_question = String.Format("Wollen Sie die gewählten {0} Journaleinträge löschen?", .SelectedObjects.Count)
                End If
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim vMainWindow As MainWindow = DirectCast(Application.Current.MainWindow, MainWindow)
                Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Löschvorgang bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)


                Dim v_selobjs_local As List(Of bookjournal_entry_v01) = CType(.SelectedObjects, List(Of bookjournal_entry_v01))

                If result = MessageDialogResult.Affirmative Then
                    While v_selobjs_local.Count > 0
                        'Delete the relation of the corresponding transaction:
                        Dim v_entry As bookjournal_entry_v01 = .SelectedObjects.First
                        dbo.m_bookjournal_entry_v01.Remove(v_entry)
                        dbo.ChangeTracker.DetectChanges()
                        v_selobjs_local.Remove(v_entry)
                        v_entry = Nothing
                    End While
                    dbo.SaveChanges()
                End If
            End With
        End Sub


        Private Function JournalEntriesDeleteCanExecute(v_journal As bookjournal_v01) As Boolean
            If v_journal Is Nothing Then Return False
            If v_journal.SelectedObjects Is Nothing Then Return False
            If v_journal.SelectedObjects.Count = 0 Then Return False
            Return True
        End Function

        Private Async Sub JournalUnlink(v_trans As transactions_v01)
            If v_trans Is Nothing Then Exit Sub
            If v_trans.nv_journal Is Nothing Then Exit Sub

            'New status is selected
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie die Verknüpfung zwischen Buchung und Journaleintrag entfernen?")
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}


            Dim v_dialog_window As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.Windows.OfType(Of Window).SingleOrDefault(Function(x) x.IsActive), MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_dialog_window.ShowMessageAsync("Verknüpfung entfernen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                With v_trans
                    .BeginEdit()
                    .nv_journal = Nothing
                    .journal_id = Nothing
                    .EndEdit()
                    dbo.SaveChanges()
                End With
            End If

        End Sub

        Private Function JournalUnlinkCanExecute(v_trans As transactions_v01) As Boolean
            If v_trans Is Nothing Then Return False
            If v_trans.nv_journal Is Nothing Then Return False
            Return True
        End Function

        ''' <summary>
        ''' Defines the timeframe which should be showed when viewing an account journal
        ''' </summary>
        ''' <param name="paras"></param>
        Private Sub JournalFilter(paras As Object())
            Dim v_journal As bookjournal_v01 = DirectCast(paras(0), bookjournal_v01)
            Dim v_timeframe_selected As cls_timeframe = DirectCast(paras(1), cls_timeframe)
            If v_journal Is Nothing Then Exit Sub
            If v_timeframe_selected Is Nothing Then Exit Sub

            Dim v_startdate As Date
            Dim v_enddate As Date

            Select Case v_timeframe_selected.Id
                Case 2
                    'Aktuelles Monat
                    v_startdate = New Date(Date.Now.Year, Date.Now.Month, 1)
                    v_enddate = v_startdate.AddMonths(1).AddDays(-1)
                    'Set the Dates to pass them to the GUI
                    v_journal.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                Case 3
                    'Letztes Monat
                    'Änderung: 1.0.1.3 Berechnung des Start Monats geändert wg. Problem mit Jahreswechsel
                    v_startdate = New Date(Date.Now.Year, Date.Now.Month, 1)
                    v_startdate = v_startdate.AddMonths(-1)
                    v_enddate = v_startdate.AddMonths(1)
                    'Set the Dates to pass them to the GUI
                    Dim v_enddate_real = v_enddate.AddDays(-1)
                    v_journal.SetShowDates(v_startdate.ToShortDateString, v_enddate_real.ToShortDateString)
                Case 4
                    'Letzten 2 Monate
                    'Änderung: 1.0.1.3 Berechnung des Start Monats geändert wg. Problem mit Jahreswechsel
                    v_startdate = New Date(Date.Now.Year, Date.Now.Month, 1)
                    v_startdate = v_startdate.AddMonths(-2)
                    v_enddate = v_startdate.AddMonths(2)
                    'Set the Dates to pass them to the GUI
                    Dim v_enddate_real = v_enddate.AddDays(-1)
                    v_journal.SetShowDates(v_startdate.ToShortDateString, v_enddate_real.ToShortDateString)
                Case 5
                    'Aktuelles Quartal
                    Select Case Date.Now.Month / 3
                        Case <= 1
                            '1.Quartal
                            v_startdate = New Date(Date.Now.Year, 1, 1)
                        Case <= 2
                            '2.Quartal
                            v_startdate = New Date(Date.Now.Year, 4, 1)
                        Case <= 3
                            '3.Quartal
                            v_startdate = New Date(Date.Now.Year, 7, 1)
                        Case <= 4
                            '4.Quartal
                            v_startdate = New Date(Date.Now.Year, 10, 1)
                    End Select
                    v_enddate = v_startdate.AddMonths(3)
                    'Set the Dates to pass them to the GUI
                    Dim v_enddate_real = v_enddate.AddDays(-1)
                    v_journal.SetShowDates(v_startdate.ToShortDateString, v_enddate_real.ToShortDateString)
                Case 6
                    'Aktuelles Halbjahr
                    If Date.Now.Month <= 6 Then
                        '1.Halbjahr
                        v_startdate = New Date(Date.Now.Year, 1, 1)
                        v_enddate = v_startdate.AddMonths(6)
                    Else
                        '2.Halbjahr
                        v_startdate = New Date(Date.Now.Year, 7, 1)
                        v_enddate = New Date(Date.Now.Year, 1, 1).AddYears(1)
                    End If
                    'Set the Dates to pass them to the GUI
                    Dim v_enddate_real = v_enddate.AddDays(-1)
                    v_journal.SetShowDates(v_startdate.ToShortDateString, v_enddate_real.ToShortDateString)
                Case 7
                    'Aktuelles Jahr
                    v_startdate = New Date(Date.Now.Year, 1, 1)
                    v_enddate = New Date(Date.Now.Year, 1, 1).AddYears(1)
                    'Set the Dates to pass them to the GUI
                    Dim v_enddate_real = v_enddate.AddDays(-1)
                    v_journal.SetShowDates(v_startdate.ToShortDateString, v_enddate_real.ToShortDateString)
                Case 8
                    'Freier Zeitraum
                    Dim v_selector As New frm_timeframe
                    Dim v_timeframe As New cls_timeframe_defined With {.start_date = New Date(Date.Now.Year, Date.Now.Month, 1), .end_date = New Date(Date.Now.Year, Date.Now.Month, DateTime.DaysInMonth(Date.Now.Year, Date.Now.Month))}
                    With v_selector
                        .DataContext = v_timeframe
                        .ShowDialog()
                        If .DialogResult Then
                            v_startdate = v_timeframe.start_date
                            v_enddate = v_timeframe.end_date
                            'Set the Dates to pass them to the GUI
                            v_journal.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                            'check if last day in month
                            If v_enddate.Day = Date.DaysInMonth(v_enddate.Year, v_enddate.Month) Then
                                v_enddate = New Date(v_enddate.Year, v_enddate.Month, 1).AddMonths(1)
                            Else
                                'move tomeframe 1 day before
                                v_enddate = v_enddate.AddDays(1)
                            End If
                        Else
                            Exit Sub
                        End If
                    End With

            End Select
            If v_journal.vcBookJournalEntries.IsLiveFiltering Then v_journal.vcBookJournalEntries.Filter = Nothing
            If Not v_journal.vcBookJournalEntries.Filter Is Nothing Then v_journal.vcBookJournalEntries.Filter = Nothing

            'Bevor filtering gleich prüfen ob nicht alle Buchungen gewählt ist:
            If v_timeframe_selected.Id = 1 Then
                v_journal.vcBookJournalEntries.Filter = Nothing
                v_journal.SetShowDates("", "")
                'Check if showunlinedonly is active:
                If v_journal.ShowUnlinkedOnly Then
                    v_journal.vcBookJournalEntries.Filter = Function(o) TryCast(o, bookjournal_entry_v01).nv_transaction Is Nothing
                End If
            Else
                'V1.0.2.2 Enddate muss kleiner gleich sein!
                If v_journal.ShowUnlinkedOnly Then
                    v_journal.vcBookJournalEntries.Filter = Function(o) TryCast(o, bookjournal_entry_v01).datum >= v_startdate AndAlso TryCast(o, bookjournal_entry_v01).datum <= v_enddate AndAlso TryCast(o, bookjournal_entry_v01).nv_transaction Is Nothing
                Else
                    v_journal.vcBookJournalEntries.Filter = Function(o) TryCast(o, bookjournal_entry_v01).datum >= v_startdate AndAlso TryCast(o, bookjournal_entry_v01).datum <= v_enddate
                End If
            End If
            v_journal.vcBookJournalEntries.Refresh()
        End Sub

        Private Function JournalFilterCanExecute(paras As Object()) As Boolean
            If paras Is Nothing Then Return False
            Dim v_journal As bookjournal_v01 = TryCast(paras(0), bookjournal_v01)
            If v_journal Is Nothing Then Return False
            Dim v_timeframe As cls_timeframe = TryCast(paras(1), cls_timeframe)
            If v_timeframe Is Nothing Then Return False
            Return True
        End Function

        Private Sub JournalSorter(v_journal As bookjournal_v01)
            If v_journal Is Nothing Then Exit Sub
            'Prüfen ob nicht bereits ein Filter aktiv ist:
            With v_journal
                If .vcBookJournalEntries.IsLiveSorting Then .vcBookJournalEntries.SortDescriptions.Clear()
                .vcBookJournalEntries.SortDescriptions.Add(New SortDescription With {.PropertyName = "datum", .Direction = ListSortDirection.Descending})
                'FEHLER 2
            End With
        End Sub

        'Private Sub JournalShowLinkedOnly(v_obj As Object())

        'End Sub

        'Private Function JournalShowLinkedOnlyCanExcute(v_obj As Object()) As Boolean
        '    Return True
        'End Function


    End Class
End Namespace

