﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity
Imports System.Reflection
Imports System.Text
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Part of MVM for defining the Dashboard:

        Public Property cmdDashboardWidgetClose As New RelayCommand(Of Object)(Sub(p) DashboardWidgetClose(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetAdd As New RelayCommand(AddressOf DashboardWidgetAdd)

        Private Sub DashboardWidgetClose(v_obj As Object)
            If v_obj Is Nothing Then Exit Sub
            'Search for the ID Property:
            Dim v_property_widget As PropertyInfo = v_obj.GetType.GetProperty("DBWidget")
            If v_property_widget Is Nothing Then Exit Sub
            Dim v_realwidget As widgets_v01 = CType(v_property_widget.GetValue(v_obj), widgets_v01)
            WidgetsDB.Remove(__widgetsdb.Where(Function(x) x.Id = v_realwidget.Id).First)
            dbo.SaveChanges()
            Widgets.Remove(v_obj)
        End Sub

        ''' <summary>
        ''' Adds a Widget to the Database collection and also to the current view:
        ''' </summary>
        Private Async Sub DashboardWidgetAdd()
            If __widgetsdb.Count >= 10 Then
                'Ask if a 11. widgets should be added because of performance.
                'New status is selected
                Dim v_strbuilder As New StringBuilder
                v_strbuilder.AppendLine("Es sind mehrere Widgets dem Dashboard hinzugefügt")
                v_strbuilder.AppendLine("eine hohe Anzahl an Widgets kann zu Performance einbußen führen")
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Widget hinzufügen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
                If Not result = MessageDialogResult.Affirmative Then Exit Sub
            End If

            Dim v_selector As New frm_widget_selector
            With v_selector
                .ShowDialog()
                If .DialogResult Then
                    If .SelectedItem Is Nothing Then Exit Sub
                    Dim v_seltuple As Tuple(Of String, String, String) = TryCast(.SelectedItem, Tuple(Of String, String, String))
                    If v_seltuple Is Nothing Then Exit Sub

                    Dim v_sortorder_new As Integer = 1
                    If __widgetsdb.Count > 0 Then v_sortorder_new += __widgetsdb.Max(Function(x) x.sortorder)
                    WidgetsDB.AddNewItem(New widgets_v01 With {.widgettype_str = v_seltuple.Item2, .sortorder = v_sortorder_new})
                    Dim v_real_widget As Object = find_single_widget(DirectCast(WidgetsDB.CurrentAddItem, widgets_v01))
                    Dim v_propinfo As PropertyInfo = v_real_widget.GetType.GetProperty("DBWidget")
                    'Pass the corresponding DB ID to the GUI object holder class:
                    v_propinfo.SetValue(v_real_widget, DirectCast(WidgetsDB.CurrentAddItem, widgets_v01))
                    WidgetsDB.CommitNew()
                        dbo.SaveChanges()
                        v_seltuple = Nothing
                        v_real_widget = Nothing
                    GetWidgetsFromDBInfo()
                    ChartsLoadAndUpdate()
                End If
            End With
        End Sub

        ''' <summary>
        ''' Function to swap the position of different widgets
        ''' </summary>
        ''' <param name="v_drag_item">Widget to be moved</param>
        ''' <param name="v_drop_item">Widget(Target) to swap</param>
        ''' <returns></returns>
        Public Function WidgetDropHandler(v_drag_item As Object, v_drop_item As Object) As Boolean
            'Get the datacontext of each objects:
            Dim v_prop_drag As PropertyInfo = v_drag_item.GetType.GetProperty("DataContext")
            Dim v_prop_drop As PropertyInfo = v_drop_item.GetType.GetProperty("DataContext")

            Dim v_drag_item_class As Object = v_prop_drag.GetValue(v_drag_item)
            Dim v_drop_item_class As Object = v_prop_drop.GetValue(v_drop_item)

            Dim v_drag_item_class_prop As PropertyInfo = v_drag_item_class.GetType.GetProperty("DBWidget")
            Dim v_drop_item_class_prop As PropertyInfo = v_drop_item_class.GetType.GetProperty("DBWidget")

            Dim v_drag_item_widget As widgets_v01 = CType(v_drag_item_class_prop.GetValue(v_drag_item_class), widgets_v01)
            Dim v_drop_item_widget As widgets_v01 = CType(v_drop_item_class_prop.GetValue(v_drop_item_class), widgets_v01)

            Dim v_db_drag_item As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_drag_item_widget.Id).FirstOrDefault
            If v_db_drag_item Is Nothing Then Return False
            Dim v_db_drag_item_sortorder_old As Integer = v_db_drag_item.sortorder

            Dim v_db_drop_item As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_drop_item_widget.Id).FirstOrDefault
            If v_db_drop_item Is Nothing Then Return False
            Dim v_db_drop_item_sortorder_old As Integer = v_db_drop_item.sortorder

            'Now edit the order:
            With v_db_drag_item
                .BeginEdit()
                .sortorder = v_db_drop_item_sortorder_old
                .EndEdit()
            End With
            With v_db_drop_item
                .BeginEdit()
                .sortorder = v_db_drag_item_sortorder_old
                .EndEdit()
            End With
            dbo.SaveChanges()
            GetWidgetsFromDBInfo()
            ChartsLoadAndUpdate()
            Return True
        End Function


        Private WithEvents __widgetsdb As New ObservableCollection(Of widgets_v01)

        Public Property WidgetsDB As ListCollectionView

        Public WithEvents Widgets As New ObservableCollection(Of Object)

        Public Property WidgetsAvailable As New List(Of Tuple(Of String, String, String)) From {
            New Tuple(Of String, String, String)("Übersicht", "cls_home_overview", "Listet alle verfügbaren Konten mit den jeweiligen aktuellen Kontoständen auf. Durch Klick auf den Kontonamen wird das Konto direkt aufgerufen"),
            New Tuple(Of String, String, String)("Kommende Buchungen", "cls_home_upcoming", "Zeigt die kommenden Wiederholungsbuchungen für einen definierten Zeitraum an."),
            New Tuple(Of String, String, String)("Nachrichten", "cls_home_messages", "Zeigt aktuelle Nachrichten und Hinweise wie z.B. durchgeführte Wiederholungsbuchungen in einer Übersicht an"),
            New Tuple(Of String, String, String)("Grafische Kontenübersicht", "cls_home_grafic", "Zeigt die aktuellen Kontostände in einer Grafik an"),
            New Tuple(Of String, String, String)("Einnahmen zu Ausgaben gesamt", "cls_home_einaus", "Zeigt die Einnahmen und Ausgaben innerhalb eines definierten Zeitbereiches an"),
            New Tuple(Of String, String, String)("Top Kategorien (Anzahl & Zeitraum)", "cls_home_topcats", "Zeigt eine definierte Anzahl von Kategorien mit den höchsten Beträgen innerhalb eines bestimmten Zeitraums an"),
            New Tuple(Of String, String, String)("Kategorien Übersicht", "cls_home_cats", "Zeigt die Beträge der gewählten Kategorien in einem Zeitraum an"),
            New Tuple(Of String, String, String)("Zieldefinition", "cls_home_targetgauge", "Zeigt die Informationen eines gegebenen Ziels grafisch an")
            }

        Private Sub DashboardLoad()
            __widgetsdb.Clear()

            dbo.m_widgets_v01.Load
            __widgetsdb = dbo.m_widgets_v01.Local

            WidgetsDB = New ListCollectionView(__widgetsdb)
            WidgetsDB.SortDescriptions.Add(New ComponentModel.SortDescription With {.PropertyName = "sortorder", .Direction = ComponentModel.ListSortDirection.Ascending})

            'Check for WidgetsAvailable:
            check_available_widgets()

            GetWidgetsFromDBInfo()
            'check if there are some charts to update:
            ChartsLoadAndUpdate()
        End Sub
        Private Property WidgetDummy As New cls_home_dummy

        ''' <summary>
        ''' Sub to add or remove the Receiver and Person Widgets depending on the settings:
        ''' </summary>
        Private Sub check_available_widgets()
            'Persons:
            If SettingsCurrent.active_person Then
                If WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_toppersons").Count = 0 Then
                    'add
                    WidgetsAvailable.Add(New Tuple(Of String, String, String)("Top Personen (Anzahl & Zeitraum)", "cls_home_toppersons", "Zeigt eine definierte Anzahl von Personen mit den höchsten Beträgen innerhalb eines bestimmten Zeitraums an"))
                End If
                If WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_persons").Count = 0 Then
                    'add
                    WidgetsAvailable.Add(New Tuple(Of String, String, String)("Personen Übersicht", "cls_home_persons", "Zeigt die Beträge der gewählten Personen in einem Zeitraum an"))
                End If
            Else
                'remove if not active
                If WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_toppersons").Count > 0 Then
                    WidgetsAvailable.Remove(WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_toppersons").FirstOrDefault)
                End If
                If WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_persons").Count > 0 Then
                    WidgetsAvailable.Remove(WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_persons").FirstOrDefault)
                End If
            End If

            'Receiver:
            If SettingsCurrent.active_receiver Then
                If WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_topreceivers").Count = 0 Then
                    'add
                    WidgetsAvailable.Add(New Tuple(Of String, String, String)("Top Empfänger (Anzahl & Zeitraum)", "cls_home_topreceivers", "Zeigt eine definierte Anzahl von Empfängern mit den höchsten Beträgen innerhalb eines bestimmten Zeitraums an"))
                End If
                If WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_receivers").Count = 0 Then
                    'add
                    WidgetsAvailable.Add(New Tuple(Of String, String, String)("Empfänger Übersicht", "cls_home_receivers", "Zeigt die Beträge der gewählten Empfänger in einem Zeitraum an"))
                End If
            Else
                'remove if not active
                If WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_topreceivers").Count > 0 Then
                    WidgetsAvailable.Remove(WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_topreceivers").FirstOrDefault)
                End If
                If WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_receivers").Count > 0 Then
                    WidgetsAvailable.Remove(WidgetsAvailable.Where(Function(x) x.Item2 = "cls_home_receivers").FirstOrDefault)
                End If
            End If

        End Sub


        'Function to set widgets based on the name of stored name in database:
        Private Function GetWidgetsFromDBInfo() As Boolean
            If WidgetsDB.Count = 0 Then
                If Not Widgets.Contains(WidgetDummy) Then Widgets.Add(WidgetDummy)
                Return True
            End If

            'Redo the sorint:
            WidgetsDB.SortDescriptions.Clear()
            WidgetsDB.SortDescriptions.Add(New ComponentModel.SortDescription With {.PropertyName = "sortorder", .Direction = ComponentModel.ListSortDirection.Ascending})

            With Widgets
                .Clear()
                For Each v_item As widgets_v01 In WidgetsDB
                    Dim v_obj As Object = find_single_widget(v_item)
                    If v_obj IsNot Nothing Then .Add(v_obj)
                    v_obj = Nothing
                Next
            End With

            'Add an empty object to have an placeholder:
            'only if the lock is not applied:
            If SettingsCurrent.home_locked = False Then If Not Widgets.Contains(WidgetDummy) Then Widgets.Add(WidgetDummy)

            Return True
        End Function



        Private Function find_single_widget(v_dbitem As widgets_v01) As Object
            If v_dbitem Is Nothing Then Return Nothing
            Dim real_widget As Object = Activator.CreateInstance(Type.GetType("HHHB3." & v_dbitem.widgettype_str))
            Dim v_propinfo As PropertyInfo = real_widget.GetType.GetProperty("DBWidget")
            v_propinfo.SetValue(real_widget, v_dbitem)
            If Not real_widget Is Nothing Then
                Return real_widget
            Else
                Return Nothing
            End If
        End Function
        Private Sub __widgetsdb_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __widgetsdb.CollectionChanged
            If Not WidgetsDB Is Nothing Then
                If Not WidgetsDB.MoveCurrentToNext Then WidgetsDB.MoveCurrentToPrevious()
                If Not WidgetsDB.IsAddingNew Or WidgetsDB.IsEditingItem Then
                    WidgetsDB.SortDescriptions.Clear()
                    WidgetsDB.SortDescriptions.Add(New ComponentModel.SortDescription With {.PropertyName = "sortorder", .Direction = ComponentModel.ListSortDirection.Ascending})
                End If
            End If
        End Sub

    End Class
End Namespace
