﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity
Imports System.Threading
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Saving Targets:

        Private WithEvents __savingtargets As New ObservableCollection(Of savingtargets_v01)
        ''' <summary>
        ''' Alle Transaktionstypen
        ''' </summary>
        ''' <returns></returns>
        Public Property SavingTargets As ListCollectionView

        Private Sub SavingTargetsLoad()
            __savingtargets.Clear()
            dbo.m_savingtargets_v01.Load
            __savingtargets = dbo.m_savingtargets_v01.Local
            SavingTargets = New ListCollectionView(__savingtargets)
            'necessary to avoid an bug which causes the duplicate and delete command to be switched of if just 1 item is available:
            SavingTargetsSelectedItems = __savingtargets.ToList
            SavingTargetsSelectedItems.Clear()
            SavingTargetsSelectedItems.Add(__savingtargets.FirstOrDefault)

            Call RecalculateAllSavingTargets()

        End Sub

        Private Sub RecalculateAllSavingTargets()
            'Now calculate the Target Values:
            For Each v_item As savingtargets_v01 In __savingtargets
                CalculateTargetValue(v_item)
            Next
        End Sub


        Private Sub __savingtargets_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __savingtargets.CollectionChanged
            If Not SavingTargets Is Nothing Then
                If Not SavingTargets.MoveCurrentToNext Then SavingTargets.MoveCurrentToPrevious()
            End If
        End Sub

        Private Sub CalculateTargetValue(v_target As savingtargets_v01)
            Dim thr_start As ThreadStart = Sub()
                                               ' Application.Current.Dispatcher.Invoke(New Action(Sub()
                                               CalculateTargetValueDo(v_target)
                                               '  End Sub))
                                           End Sub
            Dim thr As New Thread(thr_start) With {.Name = "CalculateTargetValue"}
            thr.IsBackground = True
            thr.Start()
        End Sub

        Private Sub CalculateTargetValueDo(v_target As savingtargets_v01)
            If v_target Is Nothing Then Exit Sub
            If v_target.target_value = Nothing Then Exit Sub

            'Now start a calculation:
            Dim v_konto As konto_v01 = v_target.nv_target_2_konto
            Dim v_begin As Date
            Dim v_end As Date

            'Decide based on the scope the start and end date:
            Dim v_time As cls_timeframe = __timeframestarget.Where(Function(x) x.Id = v_target.scope).FirstOrDefault
            If v_time Is Nothing Then Exit Sub

            If v_time.userdef_count Then
                v_begin = v_target.scope_free_start
                v_end = v_target.scope_free_end
            Else
                'Calculate the dates based on the scope:
                Select Case v_time.scope
                    Case "D"
                        'Scope is daily
                        If v_time.count = 1 Then
                            v_begin = Date.Now
                            v_end = Date.Now.AddDays(1)
                        Else
                            'Weekly startdate is the first day of week
                            v_begin = Date.Now.AddDays(-Weekday(Date.Now, FirstDayOfWeek.System) + 1)
                            v_end = v_begin.AddDays(7)
                        End If
                    Case "M"
                        'Scope is monthly
                        Select Case v_time.count
                            Case 1
                                v_begin = New Date(Date.Now.Year, Date.Now.Month, 1)
                                v_end = v_begin.AddMonths(1).AddDays(-1)
                            Case 3
                                Select Case Date.Now.Month / 3
                                    Case <= 1
                                        '1.Quartal
                                        v_begin = New Date(Date.Now.Year, 1, 1)
                                    Case <= 2
                                        '2.Quartal
                                        v_begin = New Date(Date.Now.Year, 4, 1)
                                    Case <= 3
                                        '3.Quartal
                                        v_begin = New Date(Date.Now.Year, 7, 1)
                                    Case <= 4
                                        '4.Quartal
                                        v_begin = New Date(Date.Now.Year, 10, 1)
                                End Select
                                v_end = v_begin.AddMonths(3)
                            Case 6
                                'Define what half of year:
                                If Date.Now.Month <= 6 Then
                                    '1. half
                                    v_begin = New Date(Date.Now.Year, 1, 1)
                                    v_end = New Date(Date.Now.Year, 7, 1).AddDays(-1)
                                Else
                                    v_begin = New Date(Date.Now.Year, 7, 1)
                                    v_end = New Date(Date.Now.Year, 12, 31)
                                End If
                        End Select
                    Case "Y"
                        'Scope is year
                        v_begin = New Date(Date.Now.Year, 1, 1)
                        v_end = New Date(Date.Now.Year, 12, 31)
                End Select
            End If

            v_target.RealStartDate = v_begin
            v_target.RealEndDate = v_end


            Dim v_value As Decimal = 0
            If v_target.track_income Then
                v_value = v_konto.nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.internal_name = "ein" AndAlso x.datum >= v_begin AndAlso x.datum <= v_end).Sum(Function(x) x.totamount)
                v_value += v_konto.nv_kto_2_trans_transfer.Where(Function(x) x.datum >= v_begin AndAlso x.datum <= v_end).Sum(Function(x) x.totamount)
            Else
                v_value = v_konto.nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.internal_name = "aus" AndAlso x.datum >= v_begin AndAlso x.datum <= v_end).Sum(Function(x) x.real_totamount)
                v_value -= v_konto.nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.internal_name = "transfer" AndAlso x.datum >= v_begin AndAlso x.datum <= v_end).Sum(Function(x) x.totamount) * -1
            End If

            v_target.current_value = v_value

            If v_target.notify_progress Then
                'Setup a Message:
                Dim v_header As String
                Dim v_msg As String = String.Format("Sie haben aktuell {0} von Ihrem Ziel {1} erreicht. Betrachtungszeitraum {2} - {3} für Konto {4}", v_target.current_value.ToString("C"), v_target.target_value.ToString("C"), v_target.RealStartDate.ToShortDateString, v_target.RealEndDate.ToShortDateString, v_konto.bezeichnung_full)
                If v_target.track_income Then
                    v_header = "Sparziel Information"
                Else
                    v_header = "Ausgabenziel Information"
                End If
                'dispatcher.Invoke(__messages.Add(New message_v01 With {.header = v_header, .message = v_msg}))
                Me.dispatcher.Invoke(Sub()
                                         MessageAdd(New message_v01 With {.header = v_header, .message = v_msg})
                                     End Sub)

            End If
        End Sub

#Region "Commands"
        Public Property cmdSavingTargetAdd As New RelayCommand(AddressOf SavingTargetAdd, Function() Konten_Aktiv.Count > 0)
        Public Property cmdSavingTargetEdit As New RelayCommand(AddressOf SavingTargetEdit, Function() SavingTargets.Count > 0 AndAlso SavingTargets.CurrentItem IsNot Nothing)
        Public Property cmdSavingTargetDuplicate As New RelayCommand(AddressOf SavingTargetsDuplicate, Function() SavingTargetCanDeleteDuplicate())
        Public Property cmdSavingTargetDelete As New RelayCommand(AddressOf SavingTargetsDelete, Function() SavingTargetCanDeleteDuplicate())
        Public Property cmdSavingTargetSelectionChanged As New RelayCommand(Of IList)(Sub(p) SavingTargetsSelectedItemsSelectionChanged(p))
        Public Property cmdSavingTargetRecalculateSelected As New RelayCommand(AddressOf SavingTargetRecalculateSelected, Function() SavingTargets IsNot Nothing AndAlso SavingTargets.Count > 0 AndAlso SavingTargetsSelectedItems.Count > 0)

        Private Sub SavingTargetAdd()
            Dim v_dia As New frm_savingtargets_addedit
            Dim v_newsavingtarget As New savingtargets_v01

            With v_dia
                .Title = "Spar/Ausgabenziel hinzufügen"
                .DataContext = v_newsavingtarget
                .ShowDialog()
                If .DialogResult Then
                    SavingTargets.AddNewItem(v_newsavingtarget)
                    SavingTargets.CommitNew()
                    dbo.SaveChanges()
                End If
            End With
        End Sub

        Private Sub SavingTargetEdit()
            Dim v_savingtarget As savingtargets_v01 = CType(SavingTargets.CurrentItem, savingtargets_v01)
            If v_savingtarget Is Nothing Then Exit Sub
            Dim v_dia As New frm_savingtargets_addedit
            v_savingtarget.BeginEdit()
            With v_dia
                .Title = "Spar/Ausgabenziel bearbeiten"
                .DataContext = v_savingtarget
                .ShowDialog()
                If .DialogResult Then
                    v_savingtarget.EndEdit()
                    dbo.SaveChanges()
                    CalculateTargetValue(v_savingtarget)
                Else
                    v_savingtarget.CancelEdit()
                End If
            End With

        End Sub

        Dim SavingTargetsSelectedItems As IList(Of savingtargets_v01)

        Private Sub SavingTargetsSelectedItemsSelectionChanged(v_selected_items As IList)
            If Not SavingTargetsSelectedItems Is Nothing Then SavingTargetsSelectedItems.Clear()
            SavingTargetsSelectedItems = CType(v_selected_items, System.Collections.IList).Cast(Of savingtargets_v01).Cast(Of savingtargets_v01).ToList
        End Sub

        ''' <summary>
        ''' Duplicates the currently selected Saving Target(s)
        ''' </summary>
        Private Async Sub SavingTargetsDuplicate()
            If SavingTargetsSelectedItems Is Nothing Or SavingTargetsSelectedItems.Count = 0 Then Exit Sub
            Dim v_question As String
            Dim v_header As String = "Spar-Ausgabenziel{0} duplizieren"
            If SavingTargetsSelectedItems.Count = 1 Then
                v_question = "Wollen Sie das gewählte Spar-Ausgabenziel duplizieren?"
                v_header = String.Format(v_header, "")
            Else
                v_question = "Wollen Sie die gewählten {0} Spar-Ausgabenziele duplizieren?"
                v_question = String.Format(v_question, SavingTargetsSelectedItems.Count.ToString)
                v_header = String.Format(v_header, "e")
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync(v_header, v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                'Start the duplicate process
                'Because the duplication process changes the Selection of the Listview we have to transfer the IDs of the formerly selected items to a list:
                Dim v_selected_ids As New List(Of Integer)
                For Each item As savingtargets_v01 In SavingTargetsSelectedItems
                    v_selected_ids.Add(item.Id)
                Next
                For Each v_item_id As Integer In v_selected_ids
                    Dim v_quelle As savingtargets_v01 = dbo.m_savingtargets_v01.First(Function(x) x.Id = v_item_id)
                    Dim v_duplicate As savingtargets_v01 = dbo.m_savingtargets_v01.AsNoTracking().First(Function(e) e.Id = v_item_id)
                    dbo.m_savingtargets_v01.Add(v_duplicate)
                    'Save to db to get the new ID
                    dbo.SaveChanges()
                    dbo.ChangeTracker.DetectChanges()
                Next
                SavingTargets.MoveCurrentToLast()
            End If
        End Sub

        Private Async Sub SavingTargetsDelete()
            If SavingTargetsSelectedItems Is Nothing Or SavingTargetsSelectedItems.Count = 0 Then Exit Sub
            Dim v_question As String
            Dim v_header As String = "Spar-Ausgabenziel{0} löschen"
            If SavingTargetsSelectedItems.Count = 1 Then
                v_question = "Wollen Sie das gewählte Spar-Ausgabenziel löschen?"
                v_header = String.Format(v_header, "")
            Else
                v_question = "Wollen Sie die gewählten {0} Spar-Ausgabenziele löschen?"
                v_question = String.Format(v_question, SavingTargetsSelectedItems.Count.ToString)
                v_header = String.Format(v_header, "e")
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync(v_header, v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                'Very stupid solution first creating a list of integer with all ids then searching with LINQ in the collection to remove ist...
                Dim v_idlist As New List(Of Integer)

                For i As Integer = 0 To SavingTargetsSelectedItems.Count - 1
                    v_idlist.Add(CType(SavingTargetsSelectedItems(i), savingtargets_v01).Id)
                Next

                For i As Integer = 0 To v_idlist.Count - 1
                    Dim v_i As Integer = i
                    __savingtargets.Remove(__savingtargets.Where(Function(x) x.Id = v_idlist(v_i)).First)
                Next
                dbo.SaveChanges()
            End If
        End Sub

        Private Function SavingTargetCanDeleteDuplicate() As Boolean
            If SavingTargetsSelectedItems Is Nothing OrElse SavingTargetsSelectedItems.Count = 0 Then Return False
            If SavingTargetsSelectedItems.Count = 1 Then
                If SavingTargetsSelectedItems.FirstOrDefault Is Nothing Then Return False
            End If
            Return True
        End Function

        ''' <summary>
        ''' Recalculates all Selected SavingTargets
        ''' </summary>
        Private Sub SavingTargetRecalculateSelected()
            If SavingTargetsSelectedItems Is Nothing OrElse SavingTargetsSelectedItems.Count = 0 Then Exit Sub
            For Each v_item As savingtargets_v01 In SavingTargetsSelectedItems
                CalculateTargetValue(v_item)
            Next
        End Sub
#End Region

    End Class

End Namespace
