﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Virtual Entity TimeFrames (for filtering)
        Private WithEvents __timeframes As New ObservableCollection(Of cls_timeframe)
        Public Property TimeFrames As ListCollectionView


        Private WithEvents __timeframestarget As New ObservableCollection(Of cls_timeframe)
        ''' <summary>
        ''' Holds the available SavingTarget Timeframes
        ''' </summary>
        ''' <returns></returns>
        Public Property TimeFramesTarget As ListCollectionView

        Private WithEvents __timeframes_view As New ObservableCollection(Of cls_timeframe)
        Public Property TimeFramesView As ListCollectionView

        Private WithEvents __timeframes_periods_report As New ObservableCollection(Of cls_timeframe)
        Public Property TimeFramesPeriodsReport As ListCollectionView

        Private Sub TimeFramesLoad()
            With __timeframes
                .Clear()
                'Add available Timeframes:
                .Add(New cls_timeframe With {.Id = 1, .bezeichnung = "Täglich", .scope = "D", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 2, .bezeichnung = "Wöchentlich", .scope = "D", .count = 7, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 3, .bezeichnung = "Monatlich", .scope = "M", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 4, .bezeichnung = "Quartalsweise", .scope = "M", .count = 3, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 5, .bezeichnung = "Halbjährlich", .scope = "M", .count = 6, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 6, .bezeichnung = "Jährlich", .scope = "Y", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 7, .bezeichnung = "alle (x) Tage", .scope = "D", .count = 0, .userdef_count = True})
                .Add(New cls_timeframe With {.Id = 8, .bezeichnung = "alle (x) Monate", .scope = "M", .count = 0, .userdef_count = True})
                .Add(New cls_timeframe With {.Id = 9, .bezeichnung = "alle (x) Jahre", .scope = "Y", .count = 0, .userdef_count = True})
            End With

            TimeFrames = CType(CollectionViewSource.GetDefaultView(__timeframes), ListCollectionView)
        End Sub

        Private Sub __timeframes_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __timeframes.CollectionChanged
            If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not TimeFrames.MoveCurrentToNext Then TimeFrames.MoveCurrentToPrevious()
        End Sub

        Private Sub TimeFramesViewLoad()
            __timeframes_view.Clear()
            With __timeframes_view
                .Add(New cls_timeframe With {.Id = 1, .bezeichnung = "Keine Einschränkung", .scope = "", .count = Nothing, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 2, .bezeichnung = "Aktuelles Monat", .scope = "M", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 3, .bezeichnung = "Letztes Monat", .scope = "M", .count = -1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 4, .bezeichnung = "Letzte 2 Monate", .scope = "M", .count = 2, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 5, .bezeichnung = "Aktuelles Quartal", .scope = "M", .count = 3, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 6, .bezeichnung = "Aktuelles Halbjahr", .scope = "M", .count = 6, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 7, .bezeichnung = "Aktuelles Jahr", .scope = "Y", .count = 1, .userdef_count = False})
                'removed from the collection because it causes problems with avalon dock tab change => with version 1.0.0.9 integrated in an extended filter
                '.Add(New cls_timeframe With {.Id = 8, .bezeichnung = "Freier Zeitraum", .scope = "", .count = Nothing, .userdef_count = True})
            End With
            TimeFramesView = CType(CollectionViewSource.GetDefaultView(__timeframes_view), ListCollectionView)
        End Sub

        Private Sub __timeframesview_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __timeframes_view.CollectionChanged
            If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not TimeFramesView.MoveCurrentToNext Then TimeFramesView.MoveCurrentToPrevious()
        End Sub

        Private Sub TimeFramesTargetLoad()
            __timeframestarget.Clear()
            With __timeframestarget
                .Add(New cls_timeframe With {.Id = 1, .bezeichnung = "Tag", .scope = "D", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 2, .bezeichnung = "Woche", .scope = "D", .count = 7, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 3, .bezeichnung = "Monat", .scope = "M", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 4, .bezeichnung = "Quartal", .scope = "M", .count = 3, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 5, .bezeichnung = "Halbjahr", .scope = "M", .count = 6, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 6, .bezeichnung = "Jahr", .scope = "Y", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 7, .bezeichnung = "Fixer Zeitraum", .scope = "", .count = 0, .userdef_count = True})
            End With
            TimeFramesTarget = CType(CollectionViewSource.GetDefaultView(__timeframestarget), ListCollectionView)
        End Sub

        Private Sub __timeframestarget_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __timeframestarget.CollectionChanged
            If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not TimeFramesTarget.MoveCurrentToNext Then TimeFramesTarget.MoveCurrentToPrevious()
        End Sub

        Private Sub TimeFramesPeriodsReportLoad()
            __timeframes_periods_report.Clear()
            With __timeframes_periods_report
                .Add(New cls_timeframe With {.Id = 1, .bezeichnung = "Tag", .scope = "D", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 2, .bezeichnung = "Woche", .scope = "D", .count = 7, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 3, .bezeichnung = "Monat", .scope = "M", .count = 1, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 4, .bezeichnung = "Quartal", .scope = "M", .count = 3, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 5, .bezeichnung = "Halbjahr", .scope = "M", .count = 6, .userdef_count = False})
                .Add(New cls_timeframe With {.Id = 6, .bezeichnung = "Jahr", .scope = "Y", .count = 1, .userdef_count = False})
            End With
            TimeFramesPeriodsReport = CType(CollectionViewSource.GetDefaultView(__timeframes_periods_report), ListCollectionView)
        End Sub

        Private Sub __timeframes_periods_report_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __timeframes_periods_report.CollectionChanged
            If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not TimeFramesPeriodsReport.MoveCurrentToNext Then TimeFramesPeriodsReport.MoveCurrentToPrevious()
        End Sub

    End Class
End Namespace