﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity
Imports System.Text
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel

        Dim v_stacktransactions As New cls_stacktransactiondefinition()
        ''' <summary>
        ''' Contains all StackTransactions, has a property which holds all defined elements of type transactions_stack which provides an property which contains the defines transactions_v01
        ''' </summary>
        ''' <returns></returns>
        Public Property StackTransactions As cls_stacktransactiondefinition
            Get
                Return v_stacktransactions
            End Get
            Set(value As cls_stacktransactiondefinition)
                v_stacktransactions = value
                RaisePropertyChanged("StackTransactions")
            End Set
        End Property

        Public Property cmdStackTransactionsExecute As New RelayCommand(Sub() TransactionsStackExecute(), Function() TransactionsStackExecuteResetCanExecute())
        Public Property cmdStackTransactionsItemReset As New RelayCommand(Sub() TransactionsStackReset(), Function() TransactionsStackExecuteResetCanExecute())

        'Command to delete a Tag from a StackTransaction:
        Public Property cmdTransStackTagDelete As New RelayCommand(Of transactions_stack)(Sub(p) TransStackTagDelete(p), Function(p) p IsNot Nothing)

        Private Async Sub TransactionsStackExecute()
            If StackTransactions Is Nothing Then Exit Sub
            If StackTransactions.StackTransactions.Count = 0 Then Exit Sub
            Dim v_errorcount As Integer = 0

            Dim v_question As String
            If StackTransactions.StackTransactions.Count = 1 Then
                v_question = "Wollen Sie die Stapelbuchung durchführen?"
            Else
                v_question = "Wollen Sie die definierten {0} Buchungen durchführen?"
                v_question = String.Format(v_question, (StackTransactions.StackTransactions.Count - 1).ToString)
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Durchführung bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result = MessageDialogResult.Affirmative Then
                Dim v_prgmsg As ProgressDialogController
                v_prgmsg = Await vMainWindow.ShowProgressAsync("Wiederholungsbuchungen", "Buchungen werden jetzt durchgeführt")
                v_prgmsg.Minimum = 1
                v_prgmsg.Maximum = StackTransactions.StackTransactions.Count
                v_prgmsg.SetProgress(1)
                Dim v_count As Integer = 1
                'Execute StackTransactions
                For Each item In StackTransactions.StackTransactions
                    'The last item is typeof newitemplaceholder
                    If TypeOf (item) Is transactions_stack Then
                        Dim v_ts As transactions_stack = DirectCast(item, transactions_stack)
                        v_prgmsg.SetProgress(v_count)
                        If v_ts.State_Executed = True Then Continue For
                        If Not v_ts.hasErrors OrElse v_ts.cont_transaction.hasErrors Then
                            v_ts.cont_transaction.TotAmountCalc()
                            Dim v_trans2add As New transactions_v01() With {
                                .comment = v_ts.cont_transaction.comment,
                                .datum = v_ts.cont_transaction.datum,
                                .journal_id = v_ts.cont_transaction.journal_id,
                                .Kategorien = v_ts.cont_transaction.Kategorien,
                                .konto_id = v_ts.cont_transaction.konto_id,
                                .person_id = v_ts.cont_transaction.person_id,
                                .receiver_id = v_ts.cont_transaction.receiver_id,
                                .to_konto_id = v_ts.cont_transaction.to_konto_id,
                                .transstatus_id = v_ts.cont_transaction.transstatus_id,
                                .transtyp_id = v_ts.cont_transaction.transtyp_id}
                            v_trans2add.nv_trans_t2k.Add(New trans_2_kat With {.category_id = v_ts.cont_category_id, .amount = v_ts.cont_amount})
                            If v_ts.cont_tag_id <> Nothing Then v_trans2add.nv_trans_transtag.Add(New trans_tag_v01 With {.tagid = v_ts.cont_tag_id})
                            v_trans2add.TotAmountCalc()
                                Transactions.AddNewItem(v_trans2add)
                                Transactions.CommitNew()
                                v_ts.State_Executed = True
                                'update the totalamount of the account:
                                If Not v_trans2add.nv_kto_2_trans_back Is Nothing Then v_trans2add.nv_kto_2_trans_back.Totalamount_Calculate()
                                If Not v_trans2add.nv_kto_2_trans_transfer_back Is Nothing Then v_trans2add.nv_kto_2_trans_transfer_back.Totalamount_Calculate()
                                v_trans2add = Nothing
                                dbo.SaveChanges()
                                v_count += 1
                            Else
                                v_ts.State_Executed = False
                        End If
                        v_ts = Nothing
                    End If
                Next

                Await v_prgmsg.CloseAsync().ConfigureAwait(True)

                'Update all Charts:
                ChartsLoadAndUpdate()
                'Update all Account Status Amounts:
                Call Konto_set_stati_all()
                'Update of all targetdefinitions:
                Call RecalculateAllSavingTargets()

            End If
        End Sub

        Private Function TransactionsStackExecuteResetCanExecute() As Boolean
            If StackTransactions Is Nothing Then Return False
            If StackTransactions.StackTransactions.Count = 0 Then Return False
            If StackTransactions.StackTransactions.Count = 1 Then
                For Each v_item As Object In StackTransactions.StackTransactions
                    If TypeOf (StackTransactions.StackTransactions.CurrentItem) IsNot transactions_stack Then Return False
                Next
            End If
            Return True
        End Function

        Private Async Sub TransactionsStackReset()
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim v_msg As New StringBuilder
            v_msg.Append("Wollen Sie den Status der Stapelbuchungen zurücksetzen?")
            v_msg.AppendLine("Hinweis: Der Status von Stapelbuchungen die von Journaleinträgen angelegt werden kann nicht zurückgesetzt werden.")
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Durchführung bestätigen", v_msg.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            v_msg = Nothing
            Dim v_show_state_message As Boolean = False

            If result = MessageDialogResult.Affirmative Then
                Try
                    For Each v_t As transactions_stack In StackTransactions.StackTransactions
                        'if the source of the transaction is an journal entry the state can't be reseted
                        If v_t.cont_transaction.journal_id Is Nothing Then
                            v_t.State_Executed = False
                        Else
                            v_show_state_message = True
                        End If
                    Next
                Catch ex As Exception
                    'Causes an error with the new item placeholder
                End Try
            End If
        End Sub

        Private Sub TransStackTagDelete(v_transstack As transactions_stack)
            If v_transstack Is Nothing Then Exit Sub
            v_transstack.cont_tag_id = Nothing
        End Sub

    End Class
End Namespace
