﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Typen:

        Private WithEvents __typen As New ObservableCollection(Of trans_typ_v01)
        ''' <summary>
        ''' Alle Transaktionstypen
        ''' </summary>
        ''' <returns></returns>
        Public Property TransTypen As ListCollectionView

        Private Sub TypenLoad()
            __typen.Clear()
            dbo.m_trans_typ_v01.Load
            __typen = dbo.m_trans_typ_v01.Local
            TransTypen = New ListCollectionView(__typen)
            'Ist es eine neue DB gibt es noch keine Typen also anlegen:
            'Konsistent der Datenbank prüfen:
            'Wenn Fehlschlag dann Programm abschießen eventuell verbessern
            If Not typen_consistency_check Then
                cls_logger.v_logger.Error("TypenLoad __typen.count Fehler count ist: " & __typen.Count.ToString & " Programm wird beendet")
                Throw New System.Exception("Die Datenbank scheint beschädigt zu sein, es gibt eine falsche Anzahl an Transaktions Typen.")
            End If
        End Sub

        Private Function typen_consistency_check() As Boolean
            Dim v_ok_count As Integer = 0

            If check_typ("ein") Then v_ok_count += 1
            If check_typ("aus") Then v_ok_count += 1
            If check_typ("transfer") Then v_ok_count += 1

            If v_ok_count = 3 Then
                Return True
            Else
                Return False
            End If
        End Function

        Private Function check_typ(v_internal As String) As Boolean
            Try
                Dim v_transtyp_enum As IEnumerable(Of trans_typ_v01)
                Dim v_multiplier As Short
                Dim v_startname As String
                Select Case v_internal
                    Case "ein"
                        v_multiplier = 1
                        v_startname = "Eingang"
                    Case "aus"
                        v_multiplier = -1
                        v_startname = "Ausgang"
                    Case Else
                        v_multiplier = 0
                        v_startname = "Transfer"
                End Select

                v_transtyp_enum = __typen.Where(Function(x) x.internal_name = v_internal)


                If v_transtyp_enum.Count = 1 Then
                    Dim v_transtyp As trans_typ_v01 = v_transtyp_enum.First
                    If Not v_transtyp.multiplier = v_multiplier Then
                        v_transtyp.BeginEdit()
                        v_transtyp.multiplier = v_multiplier
                        v_transtyp.EndEdit()
                        dbo.SaveChanges()
                    End If
                    Return True
                Else
                    'Anlegen wenn nicht vorhanden:
                    TransTypen.AddNewItem(New trans_typ_v01 With {.bezeichnung = v_startname, .internal_name = v_internal, .multiplier = v_multiplier})
                    TransTypen.CommitNew()
                    dbo.SaveChanges()
                    Return True
                End If
            Catch ex As Exception
                cls_logger.v_logger.Error("Beim Prüfen bzw. anlegen der Typen ist ein Fehler aufgetreten. Sub: check_typ mit internal: " & v_internal)
                Return False
            End Try
        End Function

        Private Sub __typen_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __typen.CollectionChanged
            If Not TransTypen Is Nothing Then
                If Not TransTypen.MoveCurrentToNext Then TransTypen.MoveCurrentToPrevious()
            End If
        End Sub

    End Class
End Namespace

